// common.cpp
////////////////////////////////////////

/*
 * Aop{֐/IuWFNg
 *  Copyright (C) 2006 肩
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <ctype.h>

#include "slibrary.h"
#include "hashtable.h"
#include "sstring.h"
#include "inifile.h"
#include "stopwatch.h"

#include "common.h"

#include "env.h"
#include "cookie.h"
#include "form.h"
#include "plugin.h"

#include "md5.h"

// ݒt@C
CIniFile ini;

// VXebZ[W
CIniFile sysmsg;
CSString message;

// ϐ
CEnv     env;
CCookie  cookie;
CForm    form;
CDirTree tree;

// s
CStopWatch timer;

// vOC
CPluginList plugins;

////////////////////////////////////////
// AvP[V̏: O[oϐn߁C낢돉
////////////////////////////////////////
int InitApplication()
{
	// ݒt@C
	{
		ini.Load("config.ini");
	}

	// VXebZ[W
	{
		CSString lang;
		lang = ini[""]["language"];
		sysmsg.Load(lang);
	}

	// ϐ
	if(env.Init()){
//		message << sysmsg["error"]["init"] << "<br>\n";
		message << sysmsg["error"]["env"]  << "<br>\n";
		return 1; // error
	}

	// ϐɁCꕔ̕ϐǉ

	// user, gallery
	if(env.IsExist("PATH_INFO")){
		int len = strlen(env["PATH_INFO"]) + 1;
		char *buf = new char [len];
		if(!buf) return 3; // error
		memcpy(buf, env["PATH_INFO"], len);

		char *ptr;
		// multi user mode
		if(!strcmp(ini[""]["mode"], "multi")){
			ptr = strchr(buf+1, '/');
			if(ptr){
				env["gallery"] = ptr+1;
				*ptr = '\0';
			}
			env["user"] = buf+1;
		}else
			env["gallery"] = buf+1;

		delete [] buf;
	}

	// top, home
	{
		CSString path ;//= "./";
		path += (const char*)ini[""]["image"];
		path += '/';
		if(!strcmp(ini[""]["mode"], "multi") && strlen(env["user"])){
			path += env["user"];
			path += '/';
		}
		env["home"] = path;

		path  = "./";
		if(!strcmp(ini[""]["mode"], "multi") && strlen(env["user"])){
			path  = env["user"];
			path += '/';
		}
		env["vhome"] = path;
	}

	// }`[U[h̎́CǉŐݒt@Cǂݍ
	if(!strcmp(ini[""]["mode"], "multi")){
		CSString path = (const char *)env["home"];
		path += "/config.ini";
		ini.Load(path);

		path = (const char*)env["home"];
		path += '/';
		path += ini[""]["language"];
		sysmsg.Load(path);
	}

	// cookie
	env["cookie"] = "1";
	if(cookie.Init()){
//		message << sysmsg["error"]["init"] << "<br>";
		message << sysmsg["error"]["cookie"] << "<br>\n";
//		return 1; // error
		env["cookie"] = "0";
	}

	// form
	env["form"] = "1";
	int max_mem = atol(ini["upload"]["max_file_size"]);
	if(max_mem <= 0) max_mem = 10*1024*1024; // 10M
	if(form.Init(CForm::GET | CForm::POST, max_mem)){
//		message << sysmsg["error"]["init"] << "<br>";
		message << sysmsg["error"]["form"] << "<br>\n";
//		return 1; // error
		env["form"] = "0";
	}

	// plugin
	{
		plugins.Open("./plugin");
	}

	// tH_̐ݒt@C
	{
		CSString path = (const char*)env["home"];
		path += (const char*)env["gallery"];
		path += "/config.ini";
		ini.Load(path);

		path  = (const char*)env["home"];
		path += (const char*)env["gallery"];
		path += '/';
		path += ini[""]["language"];
		sysmsg.Load(path);
	}

	// fBNg̓ǂݍ
	{
		CSString path = (const char*)env["home"];
		path += "/dir.txt";
		tree.Load(path);
	}

	// [UF
	{
		int auth_mode;
		auth_mode = 1; // all (ׂ)
//		auth_mode = 0; // any (ǂꂩP)

		if(!strcmp(ini["auth"]["satisfy"], "any") || !strcmp(ini["auth"]["satisfy"], "ANY"))
			auth_mode = 0;

		ini["auth"]["accept"] = "0";

		const char *ptr;
		CPlugin *plg;
		for(int i = 0; (ptr = ini["auth"]["plugin"][i]) != NULL; ++i){
			plg = plugins.Get(ptr);
			if(plg && plg->IsAuthenticated()){	// 
				if(auth_mode)	// ׂăpXKvꍇ͔F؂𑱂
					continue;
				ini["auth"]["accept"] = "1";
				break;
			}else{								// s
				if(auth_mode)	// ׂăpXKvꍇ́Cs
					break;
				continue;
			}
		}
		// ׂăpXoꍇ
		if(auth_mode && ptr == NULL)
			ini["auth"]["accept"] = "1";

		// ֎~
		ini["auth"]["accept"].Lock();
	}

	return 0;
}

// tH_̍쐬
int MakeFolder(const char * const path, const char * const target)
{
	if(!path)
		return -1;

	CSString query;
	query  = (string)env["home"];
	query += path;
	int ch;
	do{ ch = query.Chop(); } while(ch == '/');
	if(ch != -1) query += ch;

	if(target && *target){
		query += '/';
		query += target;
	}

	mkdir(query, 0777);
	chmod(query, 0777);

	return 0;
}

int RegistFolder(const char * const parent, const char * const target, const char * name)
{
	if(!parent || !target || !*target)
		return -1;

	if(!name)
		name = target;

	int ch;
	CSString newdir;
	if(strlen(parent)){
		newdir  = parent;
		do{ ch = newdir.Chop(); } while(ch == '/');
		if(ch != -1) newdir += ch;
		newdir += '/';
	}
	newdir += target;
	do{ ch = newdir.Chop(); } while(ch == '/');
	if(ch != -1) newdir += ch;

	CSString dir;
	dir  = (string)env["home"];
	dir += "dir.txt";

	FILE *fp = fopen(dir, "r+b");
	if(!fp) fp = fopen(dir, "w+b");
	if(!fp) return -2;

	flock(fileno(fp), LOCK_EX);

	CImageList list;
	list.Load(fp);

	if(!list[parent].IsExist("entries", target)){
		if(*(list[parent]["entries"]))
			list[parent]["entries"] += ", ";
		list[parent]["entries"] += target;
		list[newdir]["entries"]  = "";
		list[newdir]["name"]     = name;

		rewind(fp);
		ftruncate(fileno(fp), 0);
		list.Save(fp);
	}

//	fflush(fp);
//	flock(fileno(fp), LOCK_UN);
	fclose(fp);
	chmod(dir, 0666);

	return 0;
}

// --- pX̕ϊ ----------------------------------------------------
CSString ImageNotFound(void)
{
	CSString path;
	path = env["album"];
	path << "img/" << ini["gallery"]["noimage"];
	return path;
}
CSString MakeImagePath(CSString str)
{
	CSString imagepath;
	imagepath.Format("%s%s/%s", (string)env["home"], (string)env["gallery"], (string)str);
	return imagepath;
}

CSString MakeInfoPath(CSString str, CSString info)
{
	CSString imagepath;
	imagepath.Format("%s%s/%s/%s%s", (string)env["home"], (string)env["gallery"], (string)ini[""]["thumb"], (string)str, (string)info);
	return imagepath;
}

CSString MakeImageURI(CSString file)
{
	CSString imgpath;
	imgpath.Format("%s%s%s/%s", (string)env["album"], (string)env["home"], (string)env["gallery"], (string)file);
	return imgpath;
}
CSString MakeImageURI(CImage *image)
{
	if(((string)env["gallery"])[0] != '.')
		return MakeImageURI(image->Name());

	CSString hash;
	hash = hashSearch((*image)["hash"], "image");
	if(!hash.Length()){
		return ImageNotFound();
	}

	CSString imgpath;
	imgpath << (string)env["album"] << (string)env["home"] << (string)hash;
//	imgpath.Format("%s%s%s", (string)env["album"], (string)env["home"], (string)hash);

/*
	CSString imgpath;
	imgpath.Format("%s%s", (string)env["album"], (string)hash);
	return imgpath;
*/
	return imgpath;
}

CSString MakeThumbnailURI(CSString file)
{
	CSString thumbpath;
	thumbpath << (string)env["home"] << (string)env["gallery"] << "/.thumb/" << (string)file << ".jpg";
/*
	message << "filepath:  " << env["gallery"]  << "<br>\n";
	message << "filename : " << file  << "<br>\n";
	message << "thumbpath: " << thumbpath << "<br>\n";
*/
	CSString imgpath;
	if(access(thumbpath, R_OK)){
//		imgpath.Format("%sthumbnail/%s%s/%s", (string)env["album"], (string)env["vhome"], (string)env["gallery"], (string)file);
		imgpath << (string)env["album"] << "thumbnail/" << (string)env["vhome"] << (string)env["gallery"] << "/" << (string)file;
	}else{
//		imgpath.Format("%s%s", (string)env["album"], (string)thumbpath);
		imgpath << (string)env["album"] << (string)thumbpath;
	}

	return imgpath;
}
CSString MakeThumbnailURI(CImage *image)
{
	if(((string)env["gallery"])[0] != '.')
		return MakeThumbnailURI(image->Name());

	CSString originalfile;
	originalfile = hashSearch((*image)["hash"], "image");
	if(!originalfile.Length())
		return ImageNotFound();

	CSString filename, filepath = originalfile;
	char *ptr;
	ptr = filepath.strrchr('/');
	if(ptr){
		filename = ptr+1;
		*ptr = '\0';
		filepath.Measure();
	}else{
		filename = filepath;
		filepath = ".";
	}

	CSString thumbpath;
	thumbpath << (string)env["home"] << filepath << "/.thumb/" << filename << ".jpg";
/*
	message << "filepath:  " << filepath  << "<br>\n";
	message << "filename : " << filename  << "<br>\n";
	message << "thumbpath: " << thumbpath << "<br>\n";
*/
	CSString imgpath;
	if(access(thumbpath, R_OK)){
//		imgpath.Format("%sthumbnail/%s%s", (string)env["album"], (string)env["vhome"], (string)originalfile);
		imgpath << (string)env["album"] << "thumbnail/" << (string)env["vhome"] << (string)originalfile;
	}else{
//		imgpath.Format("%s%s", (string)env["album"], (string)thumbpath);
		imgpath << (string)env["album"] << (string)thumbpath;
	}

	return imgpath;
}

// --- t@C̐ ------------------------------------------------
/*
int CreateFile(CSString parent, CSString &realname)
{
	char *ptr;
	CSString filename;

	ptr = strrchr(parent, '/');
	if(ptr){
		*ptr++ = '\0';
		filename = ptr;
		parent.Measure();
	}else{
		filename = parent;
		parent = ".";
	}

	return CreateFile(parent, filename, realname);
}
*/

int CreateFile(CSString parent, CSString filename, CSString &realname)
{
	int fd = -1;
	CSString imgpath;

//message  << "parent " << parent << ", filename " << filename << "<br>\n";

	// test
	if(strstr(parent, "..") || strchr(filename, '/'))
		return -1;

	// 
	realname = parent + '/' + filename;
	imgpath  = env["home"];
	imgpath += "/";
	imgpath += realname; 

	fd = open(imgpath, O_WRONLY | O_CREAT | O_EXCL, 0666);
	if(fd != -1) return fd;

	char *ptr;
	CSString ext;
	ptr = strrchr(filename, '.');
	if(ptr) *ptr++ = '\0';

	ext = ptr;
	filename.Measure();

	for(int index = 0; index < 10000; ++index){
		realname.Format("%s/%s_%04d.%s", (string)parent, (string)filename, index, (string)ext);
		imgpath  = env["home"];
		imgpath << "/" << realname;
//message << imgpath << "<br>\n";
		fd = open(imgpath, O_WRONLY | O_CREAT | O_EXCL, 0666);
		if(fd != -1)
			return fd;
	}

	return -2;
}

// --- nbV ------------------------------------------------------
char *hashFromPath(const char *path)
{
	static char res[33];

	FILE *fp;
	fp = fopen(path, "rb");
	if(!fp) return NULL;

	md5_state_t state;
	md5_byte_t digest[16];
	md5_init(&state);

	char buf[4096];
	int len;
	while((len = fread(buf, sizeof(buf[0]), sizeof(buf)/sizeof(buf[0]), fp)) > 0)
		md5_append(&state, (const md5_byte_t *)buf, len);

	md5_finish(&state, digest);

	fclose(fp);

	for(int i = 0; i < 16; ++i)
		sprintf(&res[i<<1], "%02x", digest[i]);

	return res;
}

char *hashFromBuffer(const char *buf, int len)
{
	static char res[33];

	md5_state_t state;
	md5_byte_t digest[16];
	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)buf, len);
	md5_finish(&state, digest);

	for(int i = 0; i < 16; ++i)
		sprintf(&res[i<<1], "%02x", digest[i]);

	return res;
}

int hashRegist(const char * hash, const char * key, const char * path)
{
	if(!hash || !*hash || !key || !*key || !path)
		return 1;

	CSString db;
	db  = (string)env["home"];
	db += (string)ini[""]["hashdb"];
	db += '/';

	struct stat status;
	if(stat(db, &status)){
		mkdir(db, 0777);
		chmod(db, 0777);
	}

#ifdef USE_SYMBOLICLINK
	db += key;
	db += '/';

	// check directory
	if(stat(db, &status)){
		mkdir(db, 0777);
		chmod(db, 0777);
	}

	db += hash;
	// if exist old link, delete it.
	if(lstat(db, &status))
		unlink(db);

	// create link
	CSString newpath;
	newpath  = "../";
	if(!strcmp((string)ini[""]["mode"], "multi"))
		newpath += "../";
	newpath += path;
	symlink(newpath, db);

#else // default
	db += hash[0] ? hash[0] : '_';
	db += hash[1] ? hash[1] : '_';

	FILE *fp = NULL;
	fp = fopen(db, "r+b");
	if(!fp) fp = fopen(db, "w+b");
	if(!fp) return -1;

	flock(fileno(fp), LOCK_EX);

	CImageList list;
	list.Load(fp);
	if(list[hash][key] != path){
		rewind(fp);
		ftruncate(fileno(fp), 0);

		list[hash][key] = path;
		list.Save(fp);
	}

	fclose(fp);
	chmod(db, 0666);
#endif
	return 0;
}

CSString hashSearch(const char *hash, const char *key)
{
	if(!hash || !*hash || !key || !*key)
		return CSString();

	CSString res;

	CSString db;
	db  = (string)env["home"];
	db += (string)ini[""]["hashdb"];
	db += '/';

#ifdef USE_SYMBOLICLINK
	db += key;
	db += '/';
	db += hash;

	struct stat status;  
	if(!stat(db, &status)) // found
		res = db;
#else
	db += hash[0] ? hash[0] : '_';
	db += hash[1] ? hash[1] : '_';

	FILE *fp;
	fp = fopen(db, "rb");
	if(!fp) return CSString();

	CImageList list;
	list.Load(fp);
	fclose(fp);

	CSString path(list[hash][key]);
	if(!path.Length())
		return CSString();

//	res  = (string)env["home"];
	res  = path;
#endif

	return res;
}

int hashClear(const char *hash, const char *key)
{
	if(!hash || !*hash)
		return 1;

	CSString db;
	db  = (string)env["home"];
	db += (string)ini[""]["hashdb"];
	db += '/';

	struct stat status;
	if(stat(db, &status)){
		mkdir(db, 0777);
		chmod(db, 0777);
	}

#ifdef USE_SYMBOLICLINK

#else
	db += hash[0] ? hash[0] : '_';
	db += hash[1] ? hash[1] : '_';

	FILE *fp = NULL;
	fp = fopen(db, "r+b");
//	if(!fp) fp = fopen(db, "w+b");
	if(!fp) return -1;

	flock(fileno(fp), LOCK_EX);

	CImageList list;
	list.Load(fp);
	rewind(fp);
	ftruncate(fileno(fp), 0);

	if(key)
		list[hash].Remove(key);
	else
		list.RemoveGroup(hash);
	list.Save(fp);

	fclose(fp);
	chmod(db, 0666);
#endif
	return 0;
}

// --- Log -----------------------------------------------------------
int AppendLog(const char *path, const char *key, const char *log, int append, int limit)
{
	if(!path || !*path)
		return -1;

	if(!key) key = "";
	if(!log) log = "";

	int fd = open(path, O_RDWR | O_CREAT);
	if(fd < 0) return -2;

	off_t size;
	char *buf;
	do{
		flock(fd, LOCK_EX);

		if((size = lseek(fd, 0, SEEK_END)) == (off_t)-1)
			break;
		if((buf = new char [size+1]) == NULL)
			break;
		buf[size] = '\0';
		lseek(fd, 0, SEEK_SET);
		read(fd, buf, size);
		lseek(fd, 0, SEEK_SET);

		ftruncate(fd, 0);

		if(!append){
			write(fd, key, strlen(key));
			write(fd, "\t", 1);
			write(fd, log, strlen(log));
			write(fd, "\n", 1);
		}

		char *token = strtok(buf, "\n");
		char *lkey, *lvalue;
		while(token && ((limit < 0) || (--limit > 0))){
			lkey = token;
			lvalue = strchr(token, '\t');
			if(lvalue)
				*lvalue++ = '\0';
			if(strcmp(key, lkey)){
				write(fd, lkey, strlen(lkey));
				write(fd, "\t", 1);
				write(fd, lvalue, strlen(lvalue));
				write(fd, "\n", 1);
			}
			token = strtok(NULL, "\n");
		}

		if(append){
			write(fd, key, strlen(key));
			write(fd, "\t", 1);
			write(fd, log, strlen(log));
			write(fd, "\n", 1);
		}

	}while(0);

//	flock(fd, LOCK_UN);
	close(fd);
	chmod(path, 0666);

	return 0;
}

int AddRecent(const char * const hash)
{
	if(!strlen(ini[""]["recent"]))
		return 0;

	FILE *fp = NULL;

	CSString logfile;
	logfile  = env["home"];
	logfile += ini[""]["recent"];

	struct stat status;
	if(stat(logfile, &status)){
		mkdir(logfile, 0777);
		chmod(logfile, 0777);
	}

	logfile += "/images.txt";
	fp = fopen(logfile, "r+b");
	if(!fp) fp = fopen(logfile, "w+b");
	if(!fp) return -1;

	flock(fileno(fp), LOCK_EX);

	CIniFile list;
	list.Load(fp);
	ftruncate(fileno(fp), 0);
	rewind(fp);

	fprintf(fp, "[1]\nhash=%s\n", hash);

//message << "AddRecent" << logfile << "<br>\n";
//break;
	CGroup *grp;
	int i, size = atoi(ini[""]["recent_size"]);
	if(size < 0) size = 100;
	for(i = 1, grp = list.Group(); i < size && grp; grp = grp->Next()){
		if((*grp)["hash"] == hash || ((string)(*grp)["hash"])[0] == '\0')
			continue;
		fprintf(fp, "[%d]\nhash=%s\n", ++i, (string)(*grp)["hash"]);
	}

//	flock(fileno(fp), LOCK_UN);
	fclose(fp);
	chmod(logfile, 0666);

	return 0;
}

// --- Encode, Decode ------------------------------------------------
CSString Encode(CSString str)
{
	CSString res(str);
	char ch = str.GetAt(0);
	if(ch == '_' || ch == '.' || strspn(str.GetBuffer(), "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ=+-._") != str.Length()){
		res = '_';

		unsigned char data[4];
		int i, len;
		for(i = 0, len = str.GetLength(); i < len; ){
			data[0] = str.GetAt(i);					++i;
			res += Encode((data[0] & 0xFC) >> 2);
			data[1] = (i < len) ? str.GetAt(i) : 0;	++i;
			res += Encode((data[0] & 0x03) << 4 | (data[1] & 0xF0) >> 4);
			if(i > len){
				res += "==";
				break;
			}

			data[2] = (i < len) ? str.GetAt(i) : 0;	++i;
			res += Encode((data[1] & 0x0F) << 2 | (data[2] & 0xC0) >> 6);
			if(i > len){
				res += '=';
				break;
			}

			res += Encode((data[2] & 0x3F));
		}

	}

	return res;
}

char Encode(unsigned char ch)
{
	// 0x00: A, 0x19: Z
	// 0x1a: a, 0x33: z
	// 0x34: 0, 0x3d: 9
	// 0x3e: +, 0x3f: _(/)

	// error
	if(ch > 0xC0)
		return 0;

//	return "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[ch];
	return "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+_"[ch];
}

CSString Decode(CSString str)
{
	CSString res;

	char *ptr, *save;
	do{
		char *buf = new char [str.Length()+1];
		if(!buf)
			break;
		memcpy(buf, str.GetBuffer(), str.Length());
		ptr = strtok_r(buf, "/", &save);
		while(ptr){
			res += Decode(ptr);
			res += '/';
			ptr = strtok_r(NULL, "/", &save);
		}
		res.Chop();
	}while(0);

	return res;
}

CSString Decode(const char *str)
{
	CSString res;
	int count = strlen(str);
	if(str[0] != '_'){
		res = str;
	}else if(count % 4 != 1){
		CSString tmp(str);
		count = (4 - count % 4) % 4;
		while(--count)
			tmp += '=';
		return Decode(tmp);
	}else{
		unsigned char data[4];
		char buf[4];
		count = 0;
		++str;
		while(*str){
			buf[0] = *str++;
			buf[1] = *str++;
			buf[2] = *str++;
			buf[3] = *str++;

			data[0] = Decode(buf[0]);
			data[1] = Decode(buf[1]);
			res += (data[0] & 0x3F) << 2 | (data[1] & 0x30) >> 4;
			++count;

			if(buf[2] == '=')
				break;

			data[2] = Decode(buf[2]);
			res += (data[1] & 0x0F) << 4 | (data[2] & 0x3C) >> 2;
			++count;

			if(buf[3] == '=')
				break;

			data[3] = Decode(buf[3]);
			res += (data[2] & 0x03) << 6 | (data[3] & 0x3F);
			++count;
		}
	}
	return res;
}

unsigned char Decode(char ch)
{
	// 0x00: A, 0x19: Z
	// 0x1a: a, 0x33: z
	// 0x34: 0, 0x3d: 9
	// 0x3e: +, 0x3f: /

//	if(ch == '/')
	if(ch == '_')
		return 0x3f;
	if(ch == '+')
		return 0x3e;
	if('0' <= ch && ch <= '9')
		return 0x34 + ch - '0';
	if('a' <= ch && ch <= 'z')
		return 0x1a + ch - 'a';
	if('A' <= ch && ch <= 'Z')
		return 0x00 + ch - 'A';
	if(ch == '=')
		return 0;
	return '\0';
}

// path: abc/xxx_1234_5678.jpg
// folder: abc
// filename: xxx_1234_5678
// ext: jpg
int SplitPath(CSString path, CSString &folder, CSString &filename, CSString &ext)
{
	folder = "";
	filename = "";
	ext = "";

	// folder
	folder = path;

	// filename
	char *ptr;
	ptr = strrchr(folder, '/');
	if(ptr){
		*ptr++ = '\0';
		filename = ptr;
		folder.Measure();
	}else{
		filename = folder;
		folder = "";
	}

	// ext
	ptr = strrchr(filename, '.');
	if(ptr){
		*ptr++ = '\0';
		ext = ptr;
		filename.Measure();
	}

	return 0;
}

// path: abc/xxx_1234_5678.jpg
// base: xxx
// opt : _1234_5678
// ext : jpg
int SplitFilename(CSString path, CSString &base, CSString &opt, CSString &ext)
{
	base = "";
	opt  = "";
	ext  = "";

	CSString tmp;
	SplitPath(path, tmp, base, ext);

	char *ptr;
	while(1){
		ptr = strrchr(base, '_');
		if(!ptr)             break;
		if(strlen(ptr) != 5) break;
		if(!isdigit(ptr[1]) || !isdigit(ptr[2]) || !isdigit(ptr[3]) || !isdigit(ptr[4]))
			break;

		tmp  = opt;
		opt  = ptr;
		opt += tmp;
		*ptr = '\0';
	}

	return 0;
}

// archive
int ExtractArchive(const char *archive)
{
	if(!archive || !*archive)
		return -1;

	CSString parent, filename, dummy;
	SplitPath(archive, parent, filename, dummy);

	CSString archivepath;
	archivepath  = env["home"];
	archivepath << "/" << archive;

	char buf[128];
	FILE *fp = fopen(archivepath, "rb");
	if(!fp)
		return -2;
	fread(buf, sizeof(char), sizeof(buf), fp);
	fclose(fp);

	int num = 0;
	CImageList *list = NULL;
	CPlugin *plg;
	for(plg = plugins.Get(CPlugin::AX); plg; plg = plg->Next(CPlugin::AX)){
		if(plg->IsAccept(archivepath, buf)){
			message << sysmsg["archive"]["extract"] << archive << "<br>\n";

			// extract archive
			list = plg->FileList(archivepath);

			CImageList extractfiles;
			CImage *img;
			CSString realname;
			char *ext; //, *ptr;
			int fd;

			CSString hash;
            CSString path;

			// t@C̉
			for(img = list->Group(); img; img = img->Next()){
				if(!strlen(img->Name())) continue;
				ext = strrchr(img->Name(), '.');
				if(!ext || !ini["upload"].IsExist("ext", ++ext, 0)){
					message << sysmsg["upload"]["ext error"] << img->Name() << "<br>\n";
					continue;
				}

				// create new filename
				fd = CreateFile(parent, filename + "." + ext, realname);
				if(fd <= 0){
					message << sysmsg["error"]["create"] << " : " << img->Name() << "<br>\n";
					if(fd == -1)
						message << "path error" << "<br>";
					else if(fd == -2)
						message << "too" << "<br>";
					else
						message << "unknown" << "<br>";
					continue;
				}
				plg->Extract(archivepath, img->Name(), fd);
				close(fd);

				// nbṼ`FbN
				hash = hashFromPath(realname);
				path = hashSearch(hash, "image");
				if(path.Length()){
					message << sysmsg["upload"]["file exist"] << "<br>\n";

					char   *ptr = strchr(path, '/');
					if(ptr) ptr = strchr(ptr+1, '/');

					message += img->Name();
					message += ": <a href=\"";
					message += env["album"];
					message += path;
					message += "\">";
					message += ptr ? ptr+1 : path;
					message += "</a>";
					message += "<br>\n";
					continue;
				}

				extractfiles[realname]["name"] = realname;
				extractfiles[realname]["hash"] = hash;
				++num;
			}

			// 𓀂t@C̏
			for(img = extractfiles.Group(); img; img = img->Next()){
				if(!strlen(img->Name())) continue;
				// ƂƂ𓀂ꍇ
				if(ini["upload"]["extract archive"].IsTrue() && (ExtractArchive(img->Name()) > 0)){
					unlink(img->Name());
				}else{
					hashRegist((*img)["hash"], "image", img->Name());
					AddRecent((*img)["hash"]);
				}
			}
			break;
		}
	}

	if(list){
		delete list;
		// remove archive file
	}

	return num;
}

