// common.h
////////////////////////////////////////

/*
 * Aop{wb_
 *  Copyright (C) 2006 肩
 */

#ifndef __COMMON_H__
#define __COMMON_H__ 1

#define VERSION "3.1.1"

#include "slibrary.h"
#include "hashtable.h"
#include "sstring.h"
#include "inifile.h"
#include "stopwatch.h"

// ^錾
typedef const char * string;
typedef CGroup   CImage;
typedef CIniFile CDirTree;
typedef CIniFile CImageList;
typedef CIniFile CFileList;

#include "env.h"
#include "cookie.h"
#include "form.h"
#include "plugin.h"

// ݒt@C
extern CIniFile ini;

// VXebZ[W
extern CIniFile sysmsg;
extern CSString message;

// ϐ
extern CEnv     env;
extern CCookie  cookie;
extern CForm    form;
extern CDirTree tree;

// sԓ
extern CStopWatch timer;

// vOC
extern CPluginList plugins;

////////////////////////////////////////
// AvP[V̏: O[oϐn߁C낢돉
////////////////////////////////////////
int InitApplication();

////////////////////////////////////////
// tH_̍쐬
////////////////////////////////////////
int MakeFolder(const char * const parent, const char * const target = NULL);
int RegistFolder(const char * const parent, const char * const target, const char * name = NULL);

////////////////////////////////////////
// pX̕ϊ
////////////////////////////////////////
CSString MakeImagePath(CSString str);		// yyy.zzz -> xxx/yyy.zzz
//CSString MakeThumbnailPath(CSString str);	// yyy.zzz -> xxx/.thumb/yyy.zzz.jpg
#define MakeThumbnailPath(x) MakeInfoPath((x), CSString(".jpg"))
CSString MakeInfoPath(CSString str, CSString info);	// yyy.zzz -> xxx/.thumb/yyy.zzz.info

CSString MakeImageURI(CSString file);
CSString MakeImageURI(CImage *image);
CSString MakeThumbnailURI(CSString file);
CSString MakeThumbnailURI(CImage *image);

////////////////////////////////////////
// t@C̐
////////////////////////////////////////
int CreateFile(CSString parent, CSString &realname);
int CreateFile(CSString parent, CSString filename, CSString &realname);

////////////////////////////////////////
// nbV
////////////////////////////////////////
char *hashFromPath(const char *path);
char *hashFromBuffer(const char *buf, int len);

int hashRegist(const char *hash, const char *key, const char *path);
CSString hashSearch(const char *hash, const char *key);
int hashClear(const char *hash, const char *key = NULL);

////////////////////////////////////////
// O
////////////////////////////////////////
int AppendLog(const char *path, const char *key, const char *log, int append = 1, int limit = -1);
int AddRecent(const char * const hash);

////////////////////////////////////////
// }`oCg̃GR[hEfR[h
////////////////////////////////////////
CSString Encode(CSString str);
CSString Decode(CSString str);
char Encode(unsigned char);
CSString  Decode(const char *ptr);
unsigned char Decode(char);

int SplitPath(CSString path, CSString &folder, CSString &filename, CSString &ext);
int SplitFilename(CSString path, CSString &base, CSString &opt, CSString &ext);

int ExtractArchive(const char *archive);
#endif /* __COMMON_H__ */
