// env.cpp
////////////////////////////////////////

/*
 * ϐNX
 *   Copyright (C) 2006 Serika
 */

#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include "hashtable.h"
#include "env.h"

// ----- CEnv -----
// ϐ擾NX
int CEnv::Init(void)
{
	extern char** environ;
	char *buf, *ptr;
	int len;
	for(char** env=environ; *env; env++){
		len = strlen(*env) + 1;
		buf = new char [len];
		if(!buf) return 1; // s

		memcpy(buf, *env, len);
		ptr = strchr(buf, '=');
		if(ptr)
			*ptr++ = '\0';
		data[buf] = ptr;

		delete [] buf;
	}

	// XbV̏PATH_INFO, SCRIPT_NAMEĐݒ
	CheckSlash("PATH_INFO");
	CheckSlash("SCRIPT_NAME");

	// script
	const char *cptr;
	cptr = data["SCRIPT_FILENAME"];
	ptr = strrchr(cptr, '/');
	if(!ptr)
		return 2; // error
	data["script"] = ++ptr;

	// albumpath
	len = strlen(data["SCRIPT_NAME"]) + 1;
	buf = new char [len+1];
	if(!buf) return 3; // error
	memcpy(buf, data["SCRIPT_NAME"], len);
	ptr = strstr(buf, data["script"]);
	if(ptr)
		*--ptr = '\0';
	*ptr = '/';
	*++ptr = '\0';
	data["album"] = buf;
	delete [] buf;

	return 0;
}

int CEnv::CheckSlash(const char *name)
{
	// XbV̏nameĐݒ
	if(data.IsExist(name)){
		int len;
		char *buf;
		len = strlen(data[name]) + 1;
		buf = new char [len];
		memcpy(buf, data[name], len);
		if(!buf) return 3; // error

		// r̘AXbV
		{
			int i, j;
			int first;
			for(i = 0, j = 0, first = 0; buf[i]; ++i){
				if(buf[i] == '/'){
					if(first)
						continue;
					first = 1;
				}else
					first = 0;
				buf[j++] = buf[i];
			}
			buf[j] = '\0';
			len = j;
		}

		// Ō̃XbV
		while(len > 0 && buf[--len] == '/')
			buf[len] = '\0';

		data[name] = buf;
		delete [] buf;
	}

	return 0;
}

#ifdef DEBUG
int CEnv::printall(FILE *fp)
{
	int i = 0;
	for(CHashTable *ptr = &data; ptr; ptr = ptr->Next(), ++i)
		fprintf(fp, "%d: %s=%s\n", i, ptr->Name(), ptr->Value());
	return i;
}
#endif
