// hashtable.cpp
////////////////////////////////////////

/*
 * AzzNX
 *   Copyright (C) 2006 肩
 */

#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <ctype.h>

#include "slibrary.h"
#include "sstring.h"

#include "hashtable.h"

#pragma warning(disable : 4996) // Â֐̎gpɂx @ Visual C++ 2005 Express Edition

////////////////////////////////////////
// \z
////////////////////////////////////////
CHashTable::CHashTable()
{
	m_pNext = m_pPrev  = NULL;
	m_Lock = 0;

//	printf("CHashTable %p\n", this);
//	fflush(stdout);
}

CHashTable::~CHashTable()
{
//	printf("~CHashTable %p::%s = %s\n", this, (const char *)m_Name, (const char *)m_Value);
//	fflush(stdout);

	if(m_pNext){
//		printf("~CHashTable delete %p\n", m_pNext);
//		fflush(stdout);
		delete m_pNext;
	}
}

////////////////////////////////////////
// vfւ̃ANZX
////////////////////////////////////////
// vf̒ǉ
CHashTable *CHashTable::Append(const char *name, const char *value)
{
	if(!name || !*name)
		return NULL;

	CHashTable *prev = this, *next = this->Next();
	while(next){
		prev = next;
		next = next->m_pNext;
	}

	next = new CHashTable();
	if(!next) return NULL;

	next->SetName(name);
	next->SetValue(value);
	next->m_pPrev = prev;
	prev->m_pNext = next;

	return next;
}

int CHashTable::Remove(const char *name, int all)
{
	CHashTable *ptr = this;
	do{
		ptr = ptr->Search(name);
		if(!ptr) break;
		ptr = ptr->Remove();
	}while(all && ptr);

	return 0;
}

CHashTable *CHashTable::Remove(CHashTable *entry)
{
	if(!entry)
		entry = this;

	CHashTable *next = entry->m_pNext;

	if(entry->m_pPrev) entry->m_pPrev->m_pNext = entry->m_pNext;
	if(entry->m_pNext) entry->m_pNext->m_pPrev = entry->m_pPrev;

	entry->m_pNext = NULL;
	delete entry;

	return next;
}

// vf̐
int CHashTable::Count(void) const
{
/*	const CHashTable *ptr = this;
	while(ptr->pPrev)
		ptr = ptr->pPrev;
*/
	const CHashTable *ptr = this;
	int n = 1;
	while((ptr = ptr->m_pNext) != NULL)
		++n;
	return n;
}

// ľ
CHashTable *CHashTable::Search(const char *name)
{
	if(!name)
		return this;

	CHashTable *tbl = this;
	while((tbl = tbl->m_pNext) != NULL){
		if(tbl->m_Name == name)
			return tbl;
	}
	return NULL;
}

int CHashTable::IsExist(const char *name, const char *value, int (*func)(const char *, const char *))
{
	if(!name || !*name || !value || !*value)
		return 0;

	CHashTable *tbl = Search(name);
	if(!tbl)
		return 0;

	const char *ptr;
	for(int i = 0; (ptr = (*tbl)[i]) != NULL; ++i){
		if(!func(ptr, value))
			return 1;
	}

	return 0;
}


////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
// l̎o
const char *CHashTable::operator [] (int n)
{
	// 󕶎 or index͈͎̔w~X
	if(!m_Value.Length() || n < 0)
		return NULL;

	if(n == 0)
		m_Buffer = m_Value;
	else{
		char *ptr = m_Value.strchr(',', n);
		if(ptr)
			m_Buffer = ++ptr;
		else
			return NULL;
	}

	char *ptr = m_Buffer.strchr(',', 1);
	if(ptr)
		*ptr = '\0';
	m_Buffer.Triming();
/*
printf("ENTRY: %s[%d] = %s\n", (const char *)m_Value, n, (const char *)m_Buffer);
fflush(stdout);
*/
	return (const char *)m_Buffer;
}

#ifdef DEBUG
int CHashTable::printall(FILE *fp)
{
	CHashTable *tbl;
	for(tbl = this; tbl; tbl = tbl->m_pNext){
		fprintf(fp, "\t[%s]", tbl->Name());
		if(tbl->Value())
			fprintf(fp, " = [%s]", tbl->Value());
		if(tbl->m_Lock)
			fprintf(fp, " (lock)");
		fprintf(fp, "\n");
	}
	return 0;
}
#endif
