// hashtable.h
////////////////////////////////////////

/*
 * AzzNX
 *   Copyright (C) 2006 肩
 */

// Ȃ񂩁C߂ǂȂ̂ŁCǒPȂ鎩ȎQƂŎ()

#ifndef __HASHTABLE_H__
#define __HASHTABLE_H__ 1

#include <stdio.h>
#include <string.h>
#include "sstring.h"

////////////////////////////////////////////////////////////////////////////////
// AzzNX
class CHashTable
{
protected:
	CSString m_Name;
	CSString m_Value;
	CHashTable *m_pNext, *m_pPrev;

	CSString m_Buffer;

private:
	int m_Lock;

////////////////////////////////////////
// \z
////////////////////////////////////////
public:
	CHashTable();
	virtual ~CHashTable();

////////////////////////////////////////
// vfւ̃ANZX
////////////////////////////////////////
public:
	// vfo܂
	inline CHashTable &operator [] (const char *name)
			{
				CHashTable *ptr = Search(name);
				if(ptr) return *ptr;
				else    return *(Append(name));
			};

	// /O̗vfւ̃|C^Ԃ܂
	inline CHashTable *Next(void){ return m_pNext; };
	inline CHashTable *Prev(void){ return m_pPrev; };

	// vfǉ/폜܂
	CHashTable *Append(const char *name, const char *value = NULL);
	int Remove(const char *name, int all = 0); // all0ȊOɐݒ肷ƁC}b`邷ׂĂ̗vf폜܂
	CHashTable *Remove(CHashTable *entry = NULL);

	// vf̐Ԃ܂
	int Count(void) const;
	inline int Size(void) const { return Count(); };

	// w肳ꂽL[/lvfT܂
	CHashTable *Search(const char *name);
	inline int IsExist(const char *name)
			{ return Search(name) != NULL ? 1 : 0; };
	int IsExist(const char *name, const char *value, int (*func)(const char *, const char *));
	inline int IsExist(const char *name, const char *value, int flag = 1){ return IsExist(name, value, flag ? strcmp : strcasecmp); };

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
public:
	// lo܂
	inline const char *Name(void)     { return m_Name; };
	inline const char *Value(void)    { return m_Value; };
	inline operator const char *()    { return m_Value; };

	const char *operator [] (int num); // inifilepgF','؂̒l̎o

	// l̐ݒƎo
	inline const char *operator  = (const char *value) { if(!m_Lock) m_Value  = value; return value; };
	inline const char *operator += (const char *value) { if(!m_Lock) m_Value += value; return m_Value; };

	// vf̃L[ݒ肵܂
	inline const char *Name(const char *key)   { m_Name = key; return key;  };
/*	inline const char *Rename(const char *name){ m_Name = name; return name; };
	inline const char *Rename(const char *oldname, const char *newname){
			CHashTable *ent = Search(oldname);
			if(ent) ent->SetName(newname);
			else    Append(newname);
			return newname;
		}
*/

	// vf̒lݒ/ǉ܂
	inline const char *Value(const char *value) { if(!m_Lock) m_Value  = value; return value; };
	inline const char *Add(const char *value)   { if(!m_Lock) m_Value += value; return m_Value; };

	// l̏֎~܂
	inline void Lock(void) { m_Lock = 1; };

// aliases
	inline const char *GetName(void)               { return Name(); };
	inline const char *GetValue(void)              { return Value(); };
	inline const char *SetName(const char *key)    { return Name(key);  };
	inline const char *SetValue(const char *value) { return Value(value); };
	inline const char *AddValue(const char *value) { return Add(value); };

	inline int IsTrue(void) { 
		if( !strcasecmp("1", m_Value) || !strcasecmp("true", m_Value) ||
			!strcasecmp("on", m_Value) || !strcasecmp("yes", m_Value))
			return 1;
		return 0;
	};
	inline int IsFalue(void){ return !IsTrue(); };

public:
#ifdef DEBUG
	int printall(FILE *fp = stdout);
#else
	inline int printall(FILE *fp = stdout){ return 0; };
#endif
};

#endif /* __HASHTABLE_H__ */
