// inifile.cpp

/*
 * INIt@CǗpNX
 *   Copyright (C) 2006 肩 
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "slibrary.h"
#include "sstring.h"
#include "hashtable.h"

#include "inifile.h"

#pragma warning(disable : 4996) // Â֐̎gpɂx @ Visual C++ 2005 Express Edition

// ----- CGroup -----------------------------------------------------

// ׂăwb_t@CŒ`ς

// ----- Inifile ----------------------------------------------------
// ----- ƌ㏈ ---------------------------------------------
CIniFile::CIniFile()
{
}
CIniFile::~CIniFile()
{
}

// ----- t@C -----------------------------------------------
int CIniFile::Load(const char *inifile)
{
	if(!inifile || !*inifile)
		return 1;

	FILE *fp;
	fp = fopen(inifile, "rb");
	if(!fp)
		return 2;

	int res;
	res = Load(fp);
	fclose(fp);

	return res;
}

int CIniFile::Load(FILE *fp)
{
	if(!fp)
		return 2;

	CGroup *grp = &m_Group;
	char *ptr, *line;
	CSString value;
	while((line = ReadLine(fp)) != NULL){
		if(*line == '#' || *line == ';'){ //comment
			delete [] line;
			continue;
		}

		if(*line == '=' || *line == '+'){ // syntax error
			return 4;
		}else if(*line == '['){           // Group
			ptr = strchr(line+1, ']');
			if(ptr)
				*ptr = '\0';
			triming(line+1);
			grp = AddGroup(line+1);
		}else{                            // Entry
			ptr = strchr(line, '=');
			if(ptr){
				int append = (*(ptr-1) == '+') ? -1 : 0;
				*(ptr+append) = '\0';

				// key
				triming(line);
				if((*line == '"' || *line == '\'') && *line == line[strlen(line) - 1]){
					line[strlen(line) - 1] = '\0';
					++line;
				}

				// value
				triming(++ptr);
				/*if(*ptr == '$'){
					++ptr;
					value = (*grp)[ptr];
				}else */
				if((*ptr == '"' || *ptr == '\'') && *ptr == ptr[strlen(ptr) - 1]){
					ptr[strlen(ptr) - 1] = '\0';
					value = ptr + 1;
				}else{
					// ϐ̓WJ
					CHashTable tmp;
					tmp = ptr;
					value = "";
					const char *ent;
					char *prefix = "";

					for(int i = 0; (ent = tmp[i]) != NULL; ++i){
						value += prefix;
						value += (*ent == '$') ? (*grp)[ent+1] : ent;
						prefix = ", ";
					}
				}

				if(append){(*grp)[line] += ", "; (*grp)[line] += value; }
				else       (*grp)[line]  = value;
			}else{
				triming(line);
				if(*line == ptr[strlen(line) - 1] && (*line == '"' || *line == '\'')){
					line[strlen(line) - 1] = '\0';
					++line;
				}
				(*grp)[line] = "";
			}
		}
		delete [] line;
	}

	return 0;
}

int CIniFile::Save(const char *inifile)
{
	if(!inifile || !*inifile)
		return 2;

	FILE *fp;
	fp = fopen(inifile, "wb");
	if(!fp)
		return 3;

	int res;
	res = Save(fp);
	fclose(fp);

	return res;
}

int CIniFile::Save(FILE *fp)
{
	if(!fp)
		return 1;

	// date
	time_t now;
	time(&now); 
	fprintf(fp, "; %s\n", ctime(&now));

	CGroup *grp;
	CHashTable *tbl;
	for(grp = &m_Group; grp; grp = grp->Next()){
		if(*(grp->Name()))
			fprintf(fp, "[%s]\n", grp->Name());
		for(tbl = grp->Table(); tbl; tbl = tbl->Next()){
			if(*(tbl->Name())){
				fprintf(fp, "\t%s=", tbl->Name());
				if(*(tbl->Value()))
					fprintf(fp, "%s", tbl->Value());
				fprintf(fp, "\n");
			}
		}
	}

	return 0;
}

// ----- f[^̎荞 -------------------------------------------
char *CIniFile::ReadLine(FILE *fp)
{
	fpos_t pos;

	int ch;
	do{ // s̋󔒗ޕXLbv
		fgetpos(fp, &pos);
		ch = fgetc(fp);
		if(ch == EOF) return NULL; // f[^
	}while(isspace(ch));

	int count = 1;
	do{ // f[^̒JEg
		ch = fgetc(fp);
		if(ch == '\r' || ch == '\n' || ch == EOF || feof(fp))
			break;
		++count;
	}while(1);

	// m
	char *buf = new char [count+1];
	if(!buf)
		return NULL;

	fsetpos(fp, &pos);
	fread(buf, sizeof(char), count, fp);
	buf[count] = '\0';

	return buf;
}

// ----- O[v ---------------------------------------------------
CGroup *CIniFile::SearchGroup(const char *group)
{
	if(!group || !*group)
		return &m_Group;

	CGroup *grp;
	for(grp = m_Group.Next(); grp; grp = grp->Next()){
		if(!strcmp(grp->Name(), group))
			return grp;
	}

	return NULL;
}

CGroup *CIniFile::AddGroup(const char *group)
{
	if(!group || !*group)
		return &m_Group;

	CGroup *grp, *pre;
	for(pre = &m_Group, grp = m_Group.Next(); grp; pre = grp, grp = grp->Next()){
		if(!strcmp(grp->Name(), group))
			return grp;
	}
	grp = new CGroup();
	if(!grp)
		return NULL;
	grp->Rename(group);
	pre->Next(grp);
	grp->Prev(pre);

	return grp;
}

int CIniFile::RemoveGroup(CGroup *group)
{
	if(!group)
		return 1;
	if(!strlen(group->Name()))
		return 1; // can not remove default group

	CGroup *prev = group->Prev();
	if(prev)
		prev->Next(group->Next());

	group->Next(NULL);
	delete group;

	return 0;
}

#ifdef DEBUG
int CGroup::printall(FILE *fp)
{
	for(CGroup *grp = this; grp; grp = grp->Next()){
		fprintf(fp, "[%s]\n", grp->Name());
		grp->m_Table.printall(fp);
	}
	return 0;
}
#endif
