// inifile.h
////////////////////////////////////////

/*
 * INIt@CǂݍݐpNX
 *   Copyright (C) 2006 肩
 */

#ifndef __INIFILE_H__
#define __INIFILE_H__ 1

#include <stdio.h>
#include "slibrary.h"
#include "sstring.h"
#include "hashtable.h"

////////////////////////////////////////////////////////////////////////////////
// INIt@C̃O[v
class CGroup
{
protected:
//	CSString    m_Name;
	CHashTable  m_Table;
	CGroup     *m_pPrev;
	CGroup     *m_pNext;

////////////////////////////////////////
// \z
////////////////////////////////////////
public:
	CGroup()  { m_pPrev = m_pNext = NULL; };
	~CGroup() { if(m_pNext) delete m_pNext; };
	inline CGroup & operator = (CGroup *grp){ return (*this = *grp); };
	inline CGroup & operator = (CGroup &grp){
		for(CHashTable *tbl = grp.Table(); tbl; tbl = tbl->Next())
			(*this)[tbl->Name()] = tbl->Value();
		return *this;
	};

////////////////////////////////////////
// vfւ̃ANZX
////////////////////////////////////////
public:
	// vf̎o
	inline CHashTable & operator [] (const char *name)
			{ return m_Table[name]; };

	// ̗vfւ̃|C^Ԃ܂
	inline CGroup *Next(void)    { return m_pNext; };
	inline CGroup *Prev(void)    { return m_pPrev; };

	// vf̐Ԃ܂
	inline int Count(void) const { return m_Table.Count(); };
	inline int Size(void) const  { return m_Table.Size(); };

	// w肳ꂽL[vfT܂
	inline CHashTable *Search(const char *name) { return m_Table.Search(name); };
	inline int IsExist(const char *name)        { return m_Table.IsExist(name); };
	inline int IsExist(const char *name, const char *value, int (*func)(const char *, const char *))
												{ return m_Table.IsExist(name, value, func); };
	inline int IsExist(const char *name, const char *value)
	                                            { return m_Table.IsExist(name, value); };
	inline int IsExist(const char *name, const char *value, int flag)
	                                            { return m_Table.IsExist(name, value, flag); };

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
public:
	// l̎o
	inline const char *Name(void)  { return (const char *)m_Table; };
	inline CHashTable *Table(void) { return m_Table.Next(); };

	// l̐ݒ
	inline CGroup *Next(CGroup *grp)     { CGroup *old = m_pNext; m_pNext = grp; return old; };
	inline CGroup *Prev(CGroup *grp)     { CGroup *old = m_pPrev; m_pPrev = grp; return old; };
	inline void Rename(const char *name) { m_Table = name; };

	// vfǉ/폜܂
/*	inline CHashTable &Append(const char *name, const char *value = NULL)
			{ m_Table[name] = value; return m_Table[name]; };
*/
	inline int Remove(const char *name, int all = 0)
			{ return m_Table.Remove(name, all); };
	inline CHashTable * Remove(CHashTable *entry)
			{ return m_Table.Remove(entry); };

public:
#ifdef DEBUG
	int printall(FILE *fp = stdout);
#else
	inline int printall(FILE *fp = stdout){ return 0; };
#endif
};

////////////////////////////////////////////////////////////////////////////////
// INIt@Cǂݍ݃NX
class CIniFile
{
protected:
	CGroup m_Group;

////////////////////////////////////////
// \zƏ
////////////////////////////////////////
public:
	CIniFile();
	~CIniFile();

////////////////////////////////////////
// vfւ̃ANZX
////////////////////////////////////////
public:
	// vf̎o
	inline CGroup & operator [] (const char *name)
			{ return *(AddGroup(name)); };

	// w肳ꂽL[vfT܂
	CGroup *SearchGroup(const char *group);
	inline int IsExist(const char *group){ return SearchGroup(group) ? 1 : 0; }

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
public:
	// O[v̎擾
	inline CGroup *Group(void){ return &m_Group; };

	// O[v̒ǉ/폜
	CGroup *AddGroup(const char *group);
	inline int RemoveGroup(const char *group)
		{ return RemoveGroup(SearchGroup(group)); };
	int RemoveGroup(CGroup *group);

	inline int Count(void){
		CGroup *grp = &m_Group;
		int num = 0;
		while((grp = grp->Next()) != NULL)
			++num;
		return num;
	}

//	CHashTable *AddEntry(const char *group, const char *entry);
//	CHashTable *AddEntry(const char *group, const char *name, const char *value);

////////////////////////////////////////
// t@C̓ǂݍ/ւ̕ۑ
////////////////////////////////////////
public:
	int Load(const char *inifile);
	int Load(FILE *fp);
	int Save(const char *inifile);
	int Save(FILE *fp);

////////////////////////////////////////
// ⏕֐
////////////////////////////////////////
private:
	static char *ReadLine(FILE *fp);
	//static char *Triming(char *str);

public:
#ifdef DEBUG
	inline int printall(FILE *fp = stdout){ return m_Group.printall(fp); };
#else
	inline int printall(FILE *fp = stdout){ return 0; };
#endif
};

#endif /* __INIFILE_H__ */
