// plugin.cpp
////////////////////////////////////////

/*
 * AopvOCNX
 *  Copyright (C) 2006 肩
 *
 */

#include <stdio.h>

#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <dlfcn.h>
#include "common.h"

#include "sstring.h"

#include "plugin.h"

////////////////////////////////////////////////////////////////////////////////
// vOC
CPlugin::CPlugin()
{
	m_pHandle = NULL;
	m_pNext   = NULL;
	m_Type    = 0;

	fType = NULL; fInfo = NULL; fName = NULL;
	fIsAuthenticated = NULL;
	fIsAccept = NULL;
	fMakeThumbnail = NULL; fImageSize = NULL;
	fFileList = NULL; fExtract = NULL;
	fImageView = NULL;
	fRun = NULL; fExtension = fPageExtension = NULL;
}

CPlugin::~CPlugin()
{
	if(m_pHandle) dlclose(m_pHandle);
	if(m_pNext)   delete m_pNext;
}

#define LOAD_FUNCTION(name, type) \
	{ \
		f##name = type dlsym(handle, #name); \
		if((error = dlerror()) != NULL) status = -1; \
/*		else                            message += "load " #name " <br>\n"; */ \
	}

#define LOAD_FUNCTION_IFEXIST(name, type) \
	{ \
		f##name = type dlsym(handle, #name); \
	}

int CPlugin::Init(void *handle, const char *name)
{
	m_pNext = NULL;

	int status = 0;
	const char *error;

	dlerror();
	// {֐̓ǂݍ
	LOAD_FUNCTION(Type, (int (*)(void)));
	if(status) return -1;
	m_Type = (*fType)();

	LOAD_FUNCTION(Info, (const char *(*)(void)));
	LOAD_FUNCTION(Name, (const char *(*)(void)));

// Fؗp
	if(m_Type & CPlugin::AUTH){
		LOAD_FUNCTION(IsAuthenticated, (int (*)(void)));
	}

// TlC쐬EA[JCuWJpp֐
	if(m_Type & CPlugin::IF || m_Type & CPlugin::AX){
		LOAD_FUNCTION(IsAccept, (int (*)(const char *, const void *)));
	}

// TlC쐬p֐
	if(m_Type & CPlugin::IF){
		LOAD_FUNCTION(MakeThumbnail, (size (*)(const char *, const char *, int, int, int)));
		LOAD_FUNCTION(ImageSize, (size (*)(const char *, const void *)));
	}

// A[JCuWJp֐
	if(m_Type & CPlugin::AX){
		LOAD_FUNCTION(FileList, (CFileList *(*)(const char *)));
		LOAD_FUNCTION(Extract, (int (*)(const char *, const char *, int )));
	}

// M[\p֐
	if(m_Type & CPlugin::PV){
		LOAD_FUNCTION(ImageView, (int (*)(CImageList *)));
		LOAD_FUNCTION_IFEXIST(Run, (int (*)(void)));
	}

// @\gEy[Wgp֐
	if(m_Type & CPlugin::EXT || m_Type & CPlugin::PEXT){
		LOAD_FUNCTION(Run, (int (*)(void)));
	}

// @\gp֐
	if(m_Type & CPlugin::EXT){
		LOAD_FUNCTION(Extension, (int (*)(void)));
		LOAD_FUNCTION(Title, (const char *(*)(void)));
	}

// y[Wg֐
	if(m_Type & CPlugin::PEXT){
		LOAD_FUNCTION(PageExtension, (int (*)(void)));
	}

// error
	if(status) return -1;

// ׂĂ̊֐̓ǂݍ݂ɐ
	m_Name = name;
	m_pHandle = handle;

	return 0;
}

CPlugin *CPlugin::Next(unsigned int type)
{
	CPlugin *ptr;
	for(ptr = m_pNext; ptr; ptr = ptr->m_pNext){
		if(!(ptr->m_Type & type))
			continue;
		if(ini["auth"].IsExist("deny", ptr->FileName()))
			continue;
		if(strcmp(ini["auth"]["accept"], "1") && ini["auth"].IsExist("protect", ptr->FileName()))
			continue;
		break;
	}

	return ptr;
}

////////////////////////////////////////////////////////////////////////////////
// vOCǗNX
////////////////////////////////////////
// \z
////////////////////////////////////////
CPluginList::CPluginList()
{
	m_pLast = &m_Plugins.m_pNext;
}

CPluginList::~CPluginList()
{
}

int CPluginList::Open(const char *path)
{
	struct dirent **namelist;
	int n = scandir(path, &namelist, 0, alphasort);
	if (n < 0){
		message << (string)sysmsg["error"]["scandir"] << "<br>\n";
		return 0;
	}

	int num = 0;

	const char *error;
	void *handle;
	int (*function)(void);
	CPlugin *plugin;
	CSString pluginpath;
	for(int i = 0; i < n; free(namelist[i++])){
		pluginpath = path;
		pluginpath += '/';
		pluginpath += namelist[i]->d_name;

		// vOC[h
		handle = dlopen(pluginpath, RTLD_LAZY);
		if(!handle){
			continue;
		}

		// pluginpݒt@CEt@C̓ǂݏo
		{
			CSString langfile;
			langfile = pluginpath;
			langfile += ".ini";
			ini.Load(langfile);

			langfile = pluginpath;
			langfile += ".txt";
			sysmsg.Load(langfile);

			langfile = pluginpath;
			langfile += '.';
			langfile += sysmsg[""]["charset"];
			sysmsg.Load(langfile);
		}

		// L`FbN
		dlerror();
		function = (int (*)(void))dlsym(handle, "IsEnable");
		if ((error = dlerror()) != NULL){
			dlclose(handle);
			continue;
		}else if(!(*function)()){
			dlclose(handle);
			continue;
		}

		// load plugin
		plugin = new CPlugin;
		if(!plugin)
			break; // error
		if(plugin->Init(handle, namelist[i]->d_name)){
			dlclose(handle);
			delete plugin;
			continue;
		}

		++num;
		Append(plugin);
	}

	free(namelist);
	return num;
}

int CPluginList::Append(CPlugin *plugin){
	if(plugin){
		*m_pLast = plugin;
		m_pLast = &(plugin->m_pNext);
		return 0;
	}
	return 1;
}

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
CPlugin *CPluginList::Get(const char *name)
{
	if(!name || !*name)
		return NULL;

	for(CPlugin *plg = m_Plugins.m_pNext; plg; plg = plg->Next()){
		if(!strcmp(plg->FileName(), name))
			return plg;
	}

	return NULL;
}

int CPluginList::MakeThumbnail(const char *imgpath, const char *thumbpath)
{
	if(!imgpath || !*imgpath || !thumbpath || !*thumbpath)
		return 1;

	char buf[1024];
	memset(buf, 0, sizeof(buf));

	FILE *fp = fopen(imgpath, "rb");
	if(!fp) return 2;
	fread(buf, sizeof(char), sizeof(buf), fp);
	fclose(fp);

	CPlugin *plg;
	for(plg = Get(CPlugin::IF); plg; plg = plg->Next(CPlugin::IF)){
		if(plg->IsAccept(imgpath, buf))
			break;
	}
	if(!plg)
		return 3;

	int w, h;
	w = atoi(ini["thumbnail"]["width"]);  if(w <= 0) w = 120;
	h = atoi(ini["thumbnail"]["height"]); if(h <= 0) h = 120;
	plg->MakeThumbnail(imgpath, thumbpath, w, h, 0);

	return 0;
}

size CPluginList::GetImageSize(const char *imgpath)
{
	if(!imgpath || !*imgpath)
		return size(-1, -1);

	char buf[128];
	memset(buf, 0, sizeof(buf));

	FILE *fp = fopen(imgpath, "rb");
	if(!fp) return size(-1, -1);
	fread(buf, sizeof(char), sizeof(buf), fp);
	fclose(fp);

	CPlugin *plg;
	for(plg = Get(CPlugin::IF); plg; plg = plg->Next(CPlugin::IF)){
		if(plg->IsAccept(imgpath, buf))
			break;
	}
	if(!plg)
		return size(-1, -1);

	return plg->ImageSize(imgpath, buf);
}

