// plugin.h
////////////////////////////////////////

/*
 * AopvOCNX
 *  Copyright (C) 2006 肩
 */

#ifndef __PLUGIN_H__
#define __PLUGIN_H__ 1

#include "sstring.h"

class size
{
public:
	int x;
	int y;
public:
	size(int nx = -1, int ny = -1){ x = nx; y = ny; };
	~size(){};
};

////////////////////////////////////////////////////////////////////////////////
// vOC
class CPlugin
{
friend class CPluginList;
public:
	enum TYPES{
		AUTH = 0x0001,     // F
		IF   = 0x0002,     // TlC쐬
		AX   = 0x0004,     // A[JCuWJ
		EXT  = 0x0008,     // @\g
		PEXT = 0x0010,     // y[Wg
		PV   = 0x0020,     // 摜\
	};

private:
	CSString m_Name;
	void    *m_pHandle;
	CPlugin *m_pNext;
	int      m_Type;

public:
////////////////////////////////////////
// {֐
	inline int  Type(void) 
		{ if(fType && *fType) return (*fType)(); return 0; };
	inline const char *Info(void)
		{ if(fInfo && *fInfo) return (*fInfo)(); return ""; };
	inline const char *Name(void)
		{ if(fName && *fName) return (*fName)(); return ""; };

// Fؗp
	inline int IsAuthenticated(void)
		{ if(fIsAuthenticated && *fIsAuthenticated) return (*fIsAuthenticated)(); return 0; };

// TlCEA[JCuWJp
	inline int IsAccept(const char *path, const void *header)
		{ if(fIsAccept && *fIsAccept) return (*fIsAccept)(path, header); return 0; };

// TlC쐬p
	inline size MakeThumbnail(const char *in, const char *out, int width, int height, int force)
		{ if(fMakeThumbnail && *fMakeThumbnail) return (*fMakeThumbnail)(in, out, width, height, force); return size(); };
	inline size ImageSize(const char *img, const void *header)
		{ if(fImageSize && *fImageSize) return (*fImageSize)(img, header); return size(-1, -1); };

// A[JCuWJp
	inline CFileList *FileList(const char *path)
		{ if(fFileList && *fFileList) return (*fFileList)(path); return NULL; };
	inline int Extract(const char *path, const char *name, int fd)
		{ if(fExtract && *fExtract) return (*fExtract)(path, name, fd); return 0; };

// M[\p
	inline int ImageView(CImageList *imagelist)
		{ if(fImageView && *fImageView) return (*fImageView)(imagelist); return 0;};

// @\gEy[Wgp
	inline int Run(void)
		{ if(fRun && *fRun) return (*fRun)(); return 0; };

// @\gp
	inline int Extension(void)
		{ if(fExtension && *fExtension) return (*fExtension)(); return 0; };
	inline const char *Title(void)
		{ if(fTitle && *fTitle) return (*fTitle)(); return ""; };

// y[Wgp
	inline int PageExtension(void)
		{ if(fPageExtension && *fPageExtension) return (*fPageExtension)(); return 0; };

////////////////////////////////////////
// \zƏ
////////////////////////////////////////
public:
	CPlugin();
	virtual ~CPlugin();

	// nꂽnh̃vOC[hCsłԂɂ܂
	int Init(void *handle, const char *name);

////////////////////////////////////////
// vfւ̃ANZX
////////////////////////////////////////
public:
	// w肳ꂽ^Cv̎̃vOCԂ܂
	CPlugin *Next(unsigned int type = (~0));

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
public:
	inline const char *FileName(void) const { return (const char*)m_Name; };

////////////////////////////////////////
// 
////////////////////////////////////////
private: 
	int (*fIsAuthenticated)(void);

	int (*fType)(void);
	const char *(*fInfo)(void);
	const char *(*fName)(void);

	int (*fIsAccept)(const char *, const void *header);
	size (*fMakeThumbnail)(const char *, const char *, int width, int height, int force);
	size (*fImageSize)(const char *, const void *);
	CImageList *(*fFileList)(const char *path);
	int (*fExtract)(const char *path, const char *name, int fd);

	int (*fImageView)(CImageList *);
	int (*fRun)(void);
	const char *(*fTitle)(void);
	int (*fExtension)(void);
	int (*fPageExtension)(void);

////////////////////////////////////////
// Aõo[W
////////////////////////////////////////
public:
	inline const char * CompiledVersion(void){ return VERSION; };
};

////////////////////////////////////////////////////////////////////////////////
// vOCǗNX
class CPluginList
{
public:
	CPlugin m_Plugins;
	CPlugin **m_pLast;

////////////////////////////////////////
// \z
////////////////////////////////////////
public:
	CPluginList();
	virtual ~CPluginList();

public:
	int Open(const char *path);
	int Append(CPlugin *plugin);

////////////////////////////////////////
// lւ̃ANZX
////////////////////////////////////////
public:
	inline CPlugin *Get(int Type = (~0)){ return m_Plugins.Next(Type); };
	CPlugin *Get(const char *name);

////////////////////////////////////////
// vOC̗p
////////////////////////////////////////
public:
	// TlCEA[JCuWJ
	int MakeThumbnail(const char *imgpath, const char *thumbpath);
	size GetImageSize(const char *imgpath);
};

#endif /* __PLUGIN_H__ */
