// adiary.cpp
/* adiarypAbv[h@\g Copyright (C)2006 nabe@abk
              Base file ext.cpp Copyright (C)2006 肩
*/
#define MY_VERSION "1.02 (2006/10/25)"

#ifndef PLUGIN_NAME
#define PLUGIN_NAME "adiary.so"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "common.h"
#include "hashtableex.h"

#if defined (__cplusplus)
extern "C" {
#endif

const char *base_path;
unsigned int max_file_size = 0;
//##############################################################################
// vOC
//##############################################################################
int IsAuthenticated(void);
int IsEnable(void)
{	return 1; }

int Type(void)
{	return (CPlugin::AUTH | CPlugin::EXT); }

const char *Info(void)
{	return "Authorization and upload form for adiary " MY_VERSION;  }

const char *Name(void)
{	return PLUGIN_NAME; }

const char *Title(void)
{
	// return sysmsg[PLUGIN_NAME]["title"];
	return "";
}

//##############################################################################
// o̓Tu[`
//##############################################################################
/*
//-----------------------------------------------------------------------------
// wb_o
//-----------------------------------------------------------------------------
void print_header()
{
	printf("Content-Type: text/html; charset=%s\n\n", (string)sysmsg[""]["charset"]);

	const char *title = sysmsg[MSG_CLASS]["title"];
	if (!title || !*title) title = "image uploader";
	puts("<html>\n<head>");
		printf("\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=%s\">\n", (string)sysmsg[""]["charset"]);
		printf("\t<title>%s %s</title>\n", (string)ini[""]["title"], title);
		printf("\t<link rel=\"stylesheet\" href=\"%sdesign.css\" type=\"text/css\">\n",      base_path);
		printf("\t<script type=\"text/javascript\" src=\"%supload_adiary.js\"></script>\n",  base_path);
	puts("</head>");
	puts("<body>\n<div id=\"content\">");
}

inline void pirnt_footer()
{
	timer.Stop();
	printf("%s %ld.%03ld %03ld %s<br>\n", (string)sysmsg["system"]["timer_pre"], timer.Sec(), timer.MSec(), timer.USec(), (string)sysmsg["system"]["timer_post"]);
	puts("</div>\n</body></html>"); // id = content
}
*/
//-----------------------------------------------------------------------------
// l
//-----------------------------------------------------------------------------
inline long safe_atol(const char *str) {
	if (!str || !*str) return 0;
	return atol(str);
}

//-----------------------------------------------------------------------------
// TCYo
//-----------------------------------------------------------------------------
CSString get_size_string(long int size) {
	CSString size_str;
	if (size < 1024*1024)		// 1MB
		size_str.Format("%.1fKB", float(size) / 1024);
	else
		size_str.Format("%.1fMB", float(size) / (1024*1024));
	return size_str;
}

//-----------------------------------------------------------------------------
// [U[fBNg̃`FbNƍ쐬
//-----------------------------------------------------------------------------
void check_user_dir()
{
	// WfBNg̍쐬ƊmF
	CSString default_dir = (const char *)ini[PLUGIN_NAME]["default_dir"];
	{
		CSString default_dir_name = (const char *)ini[PLUGIN_NAME]["default_dir_name"];
		if (default_dir.IsEmpty()) {
			default_dir      = "adiary";
			default_dir_name = "adiary-image";
		}
		CSString dir = (const char *)env["home"];	// 摜dir
		if (access(dir + default_dir, R_OK)) {		// WfBNg݂Ȃ
			MakeFolder  ("", default_dir);
			RegistFolder("", default_dir, default_dir_name);
			MakeFolder  (default_dir, ini[""]["thumb"]);	// TlCdir
			// dir.txt ̃[h
			CSString path = (const char*)env["home"];
			path += "/dir.txt";
			tree.Load(path);
		}
	}
	// env["gallery"] = default_dir;
}

//-----------------------------------------------------------------------------
// vOCȂ
//-----------------------------------------------------------------------------
void notfound_plugin()
{
	CSString err_msg = (string)sysmsg[PLUGIN_NAME]["notfound"];
	if (err_msg.IsEmpty()) err_msg = (string)sysmsg["plugin"]["notfound"];

	puts(err_msg);
	puts("<br>");

	// VXebZ[W̕\
	//system_msg();
}

//-----------------------------------------------------------------------------
// tH[
//-----------------------------------------------------------------------------
void print_form(CPlugin *plg)
{
	// [U[fBNg̃`FbN
	check_user_dir();
	// VXebZ[W̕\
	// system_msg();
	// Abv[hvOC̃tH[s
	// env["parent"] = PLUGIN_NAME;
	plg->Extension();
	// printf("<p>max : <strong>%s</strong></p>", (string)get_size_string( max_file_size ));

	// Ao𒼐ڊJN
	const char *msg = sysmsg[PLUGIN_NAME]["album_open"];
	if (! msg || ! *msg) msg = "Open album system";
	printf("<p><a href=\"%sindex/%s\" target=\"_blank\">%s</a></p>\n", base_path, (string)env["user"], msg);
}



//-----------------------------------------------------------------------------
// POST
//-----------------------------------------------------------------------------
//^O̒u
void replace_tag(CSString *tag, const char *album_id, const char *hash, const char *shortname, const char *ext, const char *dir, const char *size)
{
	// ^O̐
	CSString _tag = *tag;
	const char *tag_text = _tag;
	*tag = "";
	for(int i=0; tag_text[i]; i++) {
		int c = tag_text[i];
		if (c != '%') {
			*tag += (const char)c;
			continue;
		}

		int next = tag_text[i+1];
		const char *copy = 0;
		if (next == 'i') copy = album_id;
		if (next == 'h') copy = hash;
		if (next == 'f') copy = shortname;	// t@C
		if (next == 'e') copy = ext;		// gq
		if (next == 'b') copy = env["album"];	// x[Xdir
		if (next == 'd') copy = dir;		// dir
		if (next == 's') copy = size;		// TCY
		if (next == '%') copy = "%";
		// u
		if (copy && *copy) {
			i++;
			*tag += copy;
		}
	}
}

//{
void post(CPlugin *plg)
{
	// POSTH
	int flag = 0;
	CSString flag_str = (string)env["upload"];
	if (flag_str == "1") flag=1;

	const char *hash     = env["upload_hash"];
	const char *filename = env["upload_filename"];
	CSString    filesize = (string)env["upload_filesize"];
	if (! flag) {
	//	system_msg();	// VXebZ[W̕\
		unsigned int content_length = safe_atol(getenv("CONTENT_LENGTH"));
		if (content_length > max_file_size) {	// t@C傫
			puts( "<h3>error</h3>" );
			const char *msg = sysmsg[PLUGIN_NAME]["too_large"];
			if (! msg || ! *msg) msg = "Upload file is too large!";
			printf( "<p><strong>" );
			printf(msg, (string)get_size_string( content_length ), (string)get_size_string( max_file_size ) );
			printf( "</strong></p>\n" );
		} else {
			puts("<h4>message</h4>\n<p>");
			puts(message);
			message = "";
		}
		if (! hash || !*hash) return ;	// s

		// nbV݂
		puts("<br>\n");
		const char *msg = sysmsg[PLUGIN_NAME]["same_file"];
		if (! msg || ! *msg) msg = "If you want to use that's file, ";
		puts(msg);
	}

	// POST
	const char *tag_msg  = sysmsg[PLUGIN_NAME]["tag_msg"];
	if (!tag_msg || !*tag_msg) tag_msg = "Please input next tag to diary.";

	const char *album_id = env["user"];
	// t@ĈݎoipXj
	char *p;
	CSString shortname = filename;
	p = rindex(filename, '/');
	if (p) shortname = p+1;
	// gqo
	CSString file_ext = shortname;
	p = rindex(file_ext, '.');
	if (p) file_ext = p+1;
	// fBNg
	CSString dir = (string)env["home"];
	dir += filename;
	while(dir.Length() && dir.Chop() != '/');
	dir += "/";
	// filesize
	if (filesize.IsEmpty()) {
		CSString file = (string)env["home"];
		file += filename;
		struct stat sb;
		if (! stat(file, &sb)) filesize.Format("%ld", (long)sb.st_size);
	}

	// 摜t@C
	int is_image = 0;
	if (ini["upload"].IsExist("images", file_ext, 0)) is_image = 1;
	// ^Oo
	CSString tag        = (string)ini[PLUGIN_NAME]["image_tag"];
	if (! is_image) tag = (string)ini[PLUGIN_NAME]["file_tag"];
	replace_tag(&tag, album_id, hash, shortname, file_ext, dir, filesize);
	printf("%s<br>\n%s<br><br>\n", tag_msg, (string)tag);

	CSString file_full;
	if (! is_image) {
		tag_msg = sysmsg[PLUGIN_NAME]["file_msg"];
		if (!tag_msg || !*tag_msg) tag_msg = "Infomation for attached file.";
		// t@Cp̃tpX
		file_full = (string)ini[PLUGIN_NAME]["file_full"];
		replace_tag(&file_full, album_id, hash, shortname, file_ext, dir, filesize);
		printf("%s<br>\n%s, %s<br><br>\n", tag_msg, (string)file_full, (string)filesize);
	}

	// JavaScripto
	if ( flag ) {
		printf("<script type=\"text/javascript\"><!--\n"
			"window.opener.insert_text(\"%s\");\n", (string)tag);
		if (! is_image) printf("window.opener.insert_file(\"%s\", %s);\n", (string)file_full, (string)filesize);
		printf("window.close();\n// --></script>\n");
	}
}

//##############################################################################
// main routine
//##############################################################################
int Extension(void)
{
	// 
	// InitInstance();
	// őTCY
	max_file_size = safe_atol(ini["upload"]["max_file_size"]);

	// x[XpXi[
	base_path = env["album"];

	// Abv[hvOC
	CPlugin *plg = plugins.Get("upload.so");
	if (plg && !(plg->Type() & CPlugin::EXT)) plg=0;

	//---------------------------------------------------------------------
	// Ct[
	//---------------------------------------------------------------------
	// HTMLwb_o
	// print_header();

	const char *method = (string)env["REQUEST_METHOD"];
	if(! plg) {	// vOCȂ
		notfound_plugin();
	} else if (! strcasecmp(method, "GET"))	 {	// GET
		print_form(plg);
	} else if (! strcasecmp(method, "POST")) {	// POST
		plg->Run();	// tH[
		post(plg);
	}

	// DEBUG message
	// debug_msg();
	// tb^o
	// pirnt_footer();
	return 0;
}

int Run(void)
{
/*	// Abv[hvOC
	CPlugin *plg = plugins.Get("upload.so");
	if (! plg) return 0;
	return plg->Run();
*/
	return 0;
}


#if defined (__cplusplus)
}
#endif
