// auth_adiary.cpp
/* F؃vOC for adiary Copyright (C)2006 nabe@abk
          Base file auth.cpp Copyright (C)2006 肩

Last-update: 2006/06/20
*/

#define COOKIE_NAME "session"
#define AUTH_CACHE  1

#ifndef PLUGIN_NAME
#define PLUGIN_NAME "auth_adiary.so"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include "common.h"
#include "hashtableex.h"

#if defined (__cplusplus)
extern "C" {
#endif

//-----------------------------------------------------------------------------
// standalone plugin
//-----------------------------------------------------------------------------
#ifdef STANDALONE

int IsAuthenticated(void);
int IsEnable(void)
{	return 1; }

int Type(void)
{	return CPlugin::AUTH; }

const char *Info(void)
{	return "Authentication for adiary";  }

const char *Name(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }
#endif

//-----------------------------------------------------------------------------
// t@CہXǂݏoiő4KBj
//-----------------------------------------------------------------------------
#define FILE_SIZE_MAX 0x1000
char *file_read( const char *file_name ) {
	int fd = open(file_name, O_RDONLY);
	if (fd < 0) return NULL;

	// obt@m
	char *buf = new char [FILE_SIZE_MAX];
	if (!buf) { close(fd); return NULL; }
	// ǂݏo
	int size = read(fd, buf, FILE_SIZE_MAX);
	buf[size] = 0;
	close(fd);
	return buf;
};

// A-Za-z0-9_݂̂Ȃ 0, ȊO 1
char check_09AZaz_string[] = {
	//0 1 2 3 4 5 6 7  8 9 a b c d e f
	  0,0,0,0,0,0,0,0, 0,0,0,1,1,1,1,1,	// 0x30-3f
	  1,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,	// 0x40-4f
	  0,0,0,0,0,0,0,0, 0,0,0,1,1,1,1,0,	// 0x50-5f
	  1,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,	// 0x60-6f
	  0,0,0,0,0,0,0,0, 0,0,0,1,1,1,1,1	// 0x70-7f
	};

int check_09AZaz_(const char *p)
{
	while(*p) {
		if (*p< 0x30 || check_09AZaz_string[int(*p) - 0x30]) return 1;
		p++;
	}
	return 0;
}

int Debug_flag = 0;
int _IsAuthenticated(void)
{
	// ̃NbL[ݒ肳Ă
	if(! cookie.IsExist(COOKIE_NAME)) { return 0; } // Invalid user

	const char *p = cookie[COOKIE_NAME];
	// copy to buffer
	int length = strlen(p);
	char buf[length+1];
	strncpy(buf, p, length);
	buf[length] = 0;
	// split by \0
	char *pbuf[16];
	int j=0;
	for(int i=0; i<length-2; i++) {
		if (buf[i] == '%' && buf[i+1] == '0' && buf[i+2] == '0') {
			buf[i]=0;
			pbuf[j++] = (buf+i+3);
			if (j>15) break;
		}
	}
	// check hash
	CSString id, sid;
	for(int i=0; i<j-1; i++) {
		if (! strcmp(pbuf[i], "id"))  { id  = pbuf[i+1]; i++; }
		if (! strcmp(pbuf[i], "sid")) { sid = pbuf[i+1]; i++; }
	}
	if (check_09AZaz_(id)) return 0;		// id ɕs
	if (id.IsEmpty() || sid.IsEmpty()) return 0;	// id, sid 

	// auth check
	CSString auth_dir = (const char *)ini[PLUGIN_NAME]["auth_dir"];
	if (auth_dir.IsEmpty()) return 0;			// auth_dir ݒ
	if (auth_dir[ auth_dir.Length() -1 ] != '/') auth_dir += "/";
	CSString auth_file = auth_dir + id + ini[PLUGIN_NAME]["auth_file_ex"];

	char *session_buf = file_read(auth_file);
	if (!session_buf) return 0;
	{	// \n to \0
		char *p = session_buf;
		while(*p) { if(*p=='\n') *p=0; p++; }
	}
	// for debug
	if (Debug_flag) {
		message << "ID : " << id << "<br>\n";
		message << "SID : " <<  sid << " (cookie)<br>\n";
		message << "SID : " << session_buf << " (system)<br>\n";
	}

	if (sid != session_buf) { delete [] session_buf; return 0; }	// session id sv
	if (Debug_flag) message << "matched<br>\n";
	delete [] session_buf;
	//-----------------------------------------------------------
	// ܂ł session ̏F͊
	//-----------------------------------------------------------
	// VO[U[[h̏ꍇ́Â܂܏F
	if (! strcmp((const char*)ini[""]["mode"],"single")) return 20;

	//-----------------------------------------------------------
	// }`[UF
	//-----------------------------------------------------------
	// AoIDsłȂ`FbN
	CSString album_id = (const char *)env["user"];
	if (Debug_flag) message << "album-ID : " << album_id << "<br>\n";
	if (album_id.IsEmpty() || check_09AZaz_(album_id)) return 0;	// album id s
	// album_id  r
	if (! strcmp(album_id, id)) return 1;		// F

	// [U[ݒt@C
	CSString setting_file = (const char *)ini[PLUGIN_NAME]["setting_dir"];
	if (setting_file[ setting_file.Length() -1 ] != '/') setting_file += "/";
	setting_file += album_id;
	setting_file += (const char *)ini[PLUGIN_NAME]["setting_file_ex"];
	if (setting_file.IsEmpty()) return 0;		// ݒt@Cݒ
	// ݒt@Cǂݏo
	CHashTableEx set;
	if (set.fread_hash( setting_file )) return 0;		// ǂݏos -> L݂Ȃ -> Fs
	// ǗҌ[U[
	if (!strcmp(set["admin_users"], "*") || set.IsExist("admin_users", id, 1)) return 3;	// true.
	// ҏW[U[
	if (!strcmp(set["edit_users"],  "*") || set.IsExist("edit_users",  id, 1)) return 2;	// true.

	// administrator ȂΏFiŌɃ`FbN邱Ɓj
	if (ini[PLUGIN_NAME].IsExist("administrator", id, 1)) return 10;
	return 0;
}

// cache
int IsAuthenticated(void) {
	static int auth = -1;
	if(!strcmp("1", ini[PLUGIN_NAME]["debug"])) Debug_flag=1;

#if AUTH_CACHE
	if (auth > 0) return auth;
#endif
	auth = _IsAuthenticated();
	if (Debug_flag) message << "auth : " << (auth ? "1 (success)<br>\n" : "0 (fail)<br>\n");
	if (auth) env["auth"] = "1";
	if (!auth || 9<auth) return auth;		// I

	// [U[fBNgȂ΍쐬
	CSString dir = (const char *)env["home"];	// 摜dir
	dir.Chop();
	if (access(dir, R_OK)) MakeFolder(""); 	// [U[fBNg݂Ȃ

	// VfBNgȂ΍쐬
	dir += "/";
	CSString recent = (const char *)ini[""]["recent"];
	if (access(dir + recent, R_OK)) {	// VfBNg݂Ȃ
		MakeFolder  ("", recent);
		RegistFolder("", recent, sysmsg["menu"]["newimg"]);
	}
	return auth;
}


#if defined (__cplusplus)
}
#endif
