// ifany.cpp

/* all-purpose thumbnail plugin
 * powered by GD Library.
 */

#include <stdio.h>
#include <string.h>
#include <gd.h>
#include <gdfonts.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "common.h"

#if defined(__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{	return 1; }

int Type(void)
{	return CPlugin::IF; }

char *Info(void)
{	return "all-purpose thumbnail plugin"; }

char *Name(void)
{	return "ifany"; }

int IsAccept(const char *path, const void *header)
{	return 1; }

size ImageSize(const char *img, const void *header)
{	return size(); }

size MakeThumbnail(const char *in, const char *out, int width, int height, int force)
{
	FILE *tp = fopen(out, "w");
	gdImagePtr thumbnail = NULL;
	gdFontPtr  font = NULL;
	int white, black;
	size imagesize;
	struct stat s_status;

	CSString tmp, file, ext;
	SplitPath(in, tmp, file, ext);

	do{
		if(!tp)
			break;

		// create thumbnail
		thumbnail = gdImageCreateTrueColor(width, height);
		if(!thumbnail)
			break;

		// status
		if(!stat(in, &s_status)){
			unsigned char buf[128];
			double size;
			char pre;
			white = gdImageColorAllocate(thumbnail, 255, 255, 255);
			black = gdImageColorAllocate(thumbnail, 0, 0, 0);  
			gdImageFilledRectangle(thumbnail, 1, 1, width-2, height-2, white);
			font = gdFontGetSmall();

			snprintf((char*)buf, sizeof(buf), "%s.%s", (string)file, (string)ext);
			gdImageString(thumbnail, font, 2, 2, buf, black);
			size = s_status.st_size;
			pre = ' ';
			if(size > 1024){ size /= 1024; pre = 'K'; }
			if(size > 1024){ size /= 1024; pre = 'M'; }
			snprintf((char*)buf, sizeof(buf), "size: %.1f%cbyte", size, pre);
			gdImageString(thumbnail, font, 2, 17, buf, black);
			strftime((char*)buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", localtime(&s_status.st_mtime));
			gdImageString(thumbnail, font, 2, 32, buf, black);
		}

		// save
		gdImageJpeg(thumbnail, tp, 90);
		fflush(tp);

		// print status
//		buf.Message("size: (%dx%d) -&gt; (%dx%d)<br>\n", x, y, width, height);

		// success
		imagesize.x = width;
		imagesize.y = height;
	}while(0);

	if(tp) fclose(tp);
	if(thumbnail) gdImageDestroy(thumbnail);

	return imagesize;
}

#if defined(__cplusplus)
}
#endif
