// pv_list.cpp

/* list view plugin */

#define PLUGIN_NAME "list.so"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{   return 1; }

int Type(void)
{   return CPlugin::PV; }

const char *Info(void)
{   return sysmsg[PLUGIN_NAME]["info"]; }

const char *Name(void)
{   return sysmsg[PLUGIN_NAME]["title"]; }

int ImageView(CImageList *imagelist)
{
	CImageList &images = *imagelist;

	CSString title;
	if(strlen(images[""]["title"]))
		title = images[""]["title"];
	else if(strlen(tree[env["gallery"]]["name"]))
		title = tree[env["gallery"]]["name"];
	else
		title = env["gallery"];

	CImage *pImg = images.Group()->Next();
	int page, page_num, num;
	// page
	{
		page     = atoi(form["page"]);
		int imagenum = images.Count();
		if(page < 0) page = 0;
		num      = atoi(ini[PLUGIN_NAME]["num"]);
		if(num <= 0) num = 10;
		page_num = (int)ceil((double)imagenum / num);

		int start;
		start = page * num;
		while(start-- > 0 && pImg)
			pImg = pImg->Next();
	}

	// title
	printf("<h4><nobr>%s(%s)</nobr></h4>\n", (string)title, (string)env["gallery"]);

	// page
	if(page_num > 1){
		puts("Page: ");
		for(int i = 0; i < page_num; i++){
			if(i == page)
				printf("%d ", i, i);
			else
				printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">%d</a> ", (string)env["album"], (string)env["vhome"], (string)env["gallery"], i, i);
		}
		puts("<br>");
	}

	puts("<div id=\"images\">");

	CSString path, thumb, str;
	CSString postfix;
	double filesize;
	for(; pImg && num-- > 0 ; pImg = pImg->Next()){
		path  = MakeImageURI(pImg);
		thumb = MakeThumbnailURI(pImg);

		postfix = "Byte";
		filesize = atof((*pImg)["size"]);
		if(filesize > 1024){ filesize /= 1024; postfix = "KByte"; }
		if(filesize > 1024){ filesize /= 1024; postfix = "MByte"; }
		if(filesize > 1024){ filesize /= 1024; postfix = "GByte"; }

		str.Format("<nobr><a href=\"%s\"><img src=\"%s\" align=\"left\"></a>"
			"<h5>%s(%s)</h5></nobr>%sx%s %.2f%s(%s) %s<br><a href=\"%shash/%s/%s\">%s</a><br><br clear=\"all\">",
			(string)path, (string)thumb,
			(string)(*pImg)["title"], pImg->Name(), 
			(string)(*pImg)["width"], (string)(*pImg)["height"],
			filesize, (string)postfix, (string)(*pImg)["size"], 
			(string)(*pImg)["key"],
			(string)env["album"], (string)env["user"], (string)(*pImg)["hash"], (string)(*pImg)["hash"]
		);
		puts(str);
	}

	puts("</div>"); // images
	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki List View Plugin</p></div>");
	return 0;
}

#if defined (__cplusplus)
}
#endif
