// mkfolder.cpp

#define PLUGIN_NAME "mkfolder.so"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{	return 1; }

int Type(void)
{	return CPlugin::EXT | CPlugin::PEXT; }

const char *Info(void)
{	return sysmsg[PLUGIN_NAME]["info"]; }

const char *Name(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

const char *Title(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

int Run(void)
{
	CFormObj *obj;

	CSString parent, target, name;

	do{
		obj = form.Search("action");
		if(!obj || strcmp(obj->Value(), "create"))
			break;

		obj = form.Search("parent");
		if(!obj) break;
		parent = obj->Value();

		obj = form.Search("target");
		if(!obj) break;
		target = obj->Value();

		obj = form.Search("name");
		if(obj && obj->Value() && *(obj->Value()))
			name = obj->Value();
		else
			name = target;

// -----
		{
			if(MakeFolder(parent, target)){
				message << (string)sysmsg[PLUGIN_NAME]["error"]
				        << parent << "/" << target
				        << "<br>\n";
				break;
			}

			MakeFolder(parent +  '/' + target, ini[""]["thumb"]);
		}

// -----

		RegistFolder(parent, target, name);

// -----

		message += (string)sysmsg[PLUGIN_NAME]["success"];
		message += "<br>\n";
		if(parent.Length()){
			message += (string)parent;
			message += "/";
		}
		message += (string)target;
		message += "<br>\n";
	}while(0);

	return 0;
}

int leaf(CDirTree &tree, CSString &node)
{
	static int loop = 0;
	if(++loop > 100)
		return 0;

	CSString nextnode, nextnode_t;
	if(node.Length()){
		nextnode_t = node;
		nextnode_t += '/';
	}

	CSString buf;
	for(int i = 0; tree[node]["entries"][i]; ++i){
		nextnode  = nextnode_t;
		nextnode += tree[node]["entries"][i];

		if(!*(tree[nextnode]["name"]))
			tree[nextnode]["name"] = tree[node]["entries"][i];
		printf("<option value=\"%s\">%s(%s)</option>\n", (string)nextnode, (string)tree[nextnode]["name"], (string)nextnode);

		if(tree[nextnode]["entries"][0]){
			leaf(tree, nextnode);
		}
	}

	return 0;
}

int Extension(void)
{
	printf("<h5>%s</h5><div><p>", (string)sysmsg[PLUGIN_NAME]["title"]);
	printf("<form action=\"%s%s/%s%s\" method=\"post\">\n", (string)env["album"], (string)env["script"], (string)env["vhome"], (string)env["gallery"]);
	puts("<input type=\"hidden\" name=\"plugin\" value=\"" PLUGIN_NAME "\">\n"
		 "<input type=\"hidden\" name=\"action\" value=\"create\">");

	puts(sysmsg[PLUGIN_NAME]["parent"]);
	puts("<select name=\"parent\">");
	printf("<option value=\"\">%s</option>", (string)sysmsg[PLUGIN_NAME]["top"]);
	CSString dummy;
	leaf(tree, dummy);
	puts("</select><br>");

	puts(sysmsg[PLUGIN_NAME]["target"]);
	puts("<input name=\"target\" size=\"40\"><br>\n");

	puts(sysmsg[PLUGIN_NAME]["name"]);
	puts("<input name=\"name\" size=\"40\"><br>\n");

	printf("<input type=\"submit\" value=\"%s\"><br>\n", (string)sysmsg[PLUGIN_NAME]["create"]);
	puts("</form>");
	puts("</p></div>");

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Create Folder Plugin</p></div>");

	return 0;
}

int PageExtension(void)
{
	printf( "<form action=\"%s%s/%s%s\" method=\"post\">\n", (string)env["album"], (string)env["script"], (string)env["vhome"], (string)env["gallery"]);
	printf( "<input type=\"hidden\" name=\"plugin\" value=\"" PLUGIN_NAME "\">\n"
			"<input type=\"hidden\" name=\"action\" value=\"create\">"
			"<input type=\"hidden\" name=\"parent\" value=\"%s\">",
			(string)env["gallery"]
	);

	puts(sysmsg[PLUGIN_NAME]["target"]);
	puts("<input name=\"target\" size=\"40\"><br>\n");

	puts(sysmsg[PLUGIN_NAME]["name"]);
	puts("<input name=\"name\" size=\"40\"><br>\n");

	printf("<input type=\"submit\" value=\"%s\"><br>\n", (string)sysmsg[PLUGIN_NAME]["create"]);
	puts("</form>");

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Create Folder Plugin</p></div>");

	return 0;
}

#if defined (__cplusplus)
}
#endif
