// plugin_info.cpp


#define PLUGIN_NAME "plugin_info.so"

#include <stdio.h>
#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{	return 1; }

int Type(void)
{
	return CPlugin::EXT;
}

const char *Info(void)
{	return sysmsg[PLUGIN_NAME]["info"]; }

const char *Name(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

const char *Title(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

int Run(void)
{	return 0; }

int PrintPluginStatus(CPlugin *plg)
{
	puts("<li>");
	puts(plg->Name());
	puts("<br>");

	// type
	puts(sysmsg[PLUGIN_NAME]["plugin type"]);
	int type = plg->Type();
	if(type & CPlugin::AUTH){ puts(sysmsg[PLUGIN_NAME]["auth"]); };
	if(type & CPlugin::IF)  { puts(sysmsg[PLUGIN_NAME]["if"]); };
	if(type & CPlugin::AX)  { puts(sysmsg[PLUGIN_NAME]["ax"]); };
	if(type & CPlugin::EXT) { puts(sysmsg[PLUGIN_NAME]["ext"]); };
	if(type & CPlugin::PEXT){ puts(sysmsg[PLUGIN_NAME]["pext"]); };
	if(type & CPlugin::PV)  { puts(sysmsg[PLUGIN_NAME]["pv"]); };
	puts("<br>");
	
	// info
	puts(sysmsg[PLUGIN_NAME]["plugin info"]);
	puts(plg->Info());
	puts("<br>");

	// version
	puts(sysmsg[PLUGIN_NAME]["album ver"]);
	puts(plg->CompiledVersion());
	
	return 0;
}

int Extension(void)
{
	printf("<h5>%s</h5><div><p>", (string)sysmsg[PLUGIN_NAME]["title"]);

	puts("<ol>");
	CSString logfile;
	for(CPlugin *plg = plugins.Get(); plg; plg = plg->Next()){
		PrintPluginStatus(plg);
	}
	puts("</ol>");

	puts("</p></div>");

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Plugin Info Plugin</p></div>");

	return 0;
}

#if defined (__cplusplus)
}
#endif
