// exbbs.cpp

/* PsfvOC */

#define PLUGIN_NAME "simplebbs.so"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{
	if(!strcmp((string)env["script"], "gallery") && (!*(string)env["gallery"] || *(string)env["gallery"] == '.'))
		return 0;
	return 1;
}

int Type(void)
{
	int flag = 0;
	if(!ini[PLUGIN_NAME].IsExist("disable", "EXT"))
		flag |= CPlugin::EXT;
	if(!ini[PLUGIN_NAME].IsExist("disable", "PEXT"))
		flag |= CPlugin::PEXT;
	return flag;
}

const char *Info(void)
{	return "Simple BBS"; }

const char *Name(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

const char *Title(void)
{	return sysmsg[PLUGIN_NAME]["title"]; }

int Run(void)
{
	int fd = 0;
	char *token, *buffer;
	char date[32];
	int size;
	CSString name, log, logfile, folder;

	do{
		CFormObj *obj;
		obj = form.Search("action");
		if(!obj || strcmp(obj->Value(), "write"))
			break;

// -----

		int count;
		if(ini[PLUGIN_NAME].IsExist("num"))
			count = atoi(ini[PLUGIN_NAME]["num"]);
		else
			count = 50;

		const char *ptr;
		int skip;
		obj = form.Search("name");
		if(!obj || !obj->Value()) break;
		for(skip = 0, ptr = obj->Value(); *ptr; ++ptr){
			if(skip){
				name += *ptr;
				skip = 0;
				continue;
			}
			if(*ptr == '>')
				name += "&gt;";
			else if(*ptr == '<')
				name += "&lt;";
			else
				name += *ptr;
			if(*ptr < 0x20 || 0x7e < *ptr)
				skip = 1;
		}

		obj = form.Search("log");
		if(!obj || !obj->Value()) break;
		for(skip = 0, ptr = obj->Value(); *ptr; ++ptr){
			if(skip){
				log += *ptr;
				skip = 0;
				continue;
			}

			if(*ptr == '>')
				log += "&gt;";
			else if(*ptr == '<'){
				if(!strncmp(ptr, "<br>", 4)){
					log += "<br>";
					ptr += 3;
				}else
					log += "&lt;";
			}
			else
				log += *ptr;
			if(*ptr < 0x20 || 0x7e < *ptr)
				skip = 1;
		}

		obj = form.Search("folder");
		if(obj && obj->Value() && *obj->Value()){
			folder  = obj->Value();
			folder += '/';
		}else
			folder = "";

// -----

		time_t now = time(NULL);
		strftime(date, sizeof(date), "%Y-%m-%d %H:%M:%S", localtime(&now));

		logfile  = (string)env["home"];
		logfile += (string)folder;
		logfile += (string)ini[PLUGIN_NAME]["file"];

		if((fd = open(logfile, O_RDWR | O_CREAT)) < 0)
			break;

		flock(fd, LOCK_EX);

		if((size = lseek(fd, 0, SEEK_END)) < 0)
			break;
		if((buffer = new char [size+1]) == NULL)
			break;
		buffer[size] = '\0';
		lseek(fd, 0, SEEK_SET);
		read(fd, buffer, size);
		lseek(fd, 0, SEEK_SET);

		ftruncate(fd, 0);
		write(fd, name, strlen(name));
		write(fd, "\t", 1);
		write(fd, date, strlen(date));
		write(fd, "\t", 1);
		write(fd, log, strlen(log));
		write(fd, "\n", 1);
		token = strtok(buffer, "\n");
		while(--count && token){
			write(fd, token, strlen(token));
			write(fd, "\n", 1);
			token = strtok(NULL, "\n");
		}

	}while(0);

	if(fd >= 0){
		flock(fd, LOCK_UN);
		close(fd);
		chmod(logfile, 0666);
	}

	return 0;
}

int PrintLog(const char *path)
{
	int fd = 0;
	char *buffer = NULL;

	do{
		int size;
		if((fd  = open(path, O_RDONLY)) < 0)
			break;
		if((size = lseek(fd, 0, SEEK_END)) < 0)
			break;
		if((buffer = new char [size+1]) == NULL)
			break;

		buffer[size] = '\0';
		lseek(fd, 0, SEEK_SET);
		read(fd, buffer, size);
		close(fd); fd = -1;
		chmod(path, 0666);

		int count;
		char *log, *date;
		char *name = strtok(buffer, "\n");
		for(count = 0; name; count = !count, name = strtok(NULL, "\n")){
			if(*name){
				date = strchr(name, '\t');	*date++ = '\0';
				log  = strchr(date, '\t');	*log++  = '\0';
				if(count)	printf("<tr><td class=\"td_even\"><nobr>%s</nobr></td><td class=\"td_even\">%s (%s)</td></tr>\n", name, log, date);
				else		printf("<tr><td class=\"td_odd\"><nobr>%s</nobr></td><td class=\"td_odd\">%s (%s)</td></tr>\n", name, log, date);
			}
		}
	}while(0);

	if(buffer)
		delete [] buffer;
	if(fd >= 0)
		close(fd);
	return 0;
}

int Extension(void)
{
	printf("<h5>%s</h5><div><p>", (string)sysmsg[PLUGIN_NAME]["title"]);
	printf("<form action=\"%s%s/%s%s\" method=\"post\">\n", (string)env["album"], (string)env["script"], (string)env["vhome"], (string)env["gallery"]);
	puts("<input type=\"hidden\" name=\"plugin\" value=\"" PLUGIN_NAME "\">\n"
		"<input type=\"hidden\" name=\"action\" value=\"write\">\n"
		"<input type=\"text\" name=\"name\" size=\"20\">\n"
		"<input type=\"text\" name=\"log\" size=\"80\">");
	printf("<input type=\"submit\" value=\"%s\">", (string)sysmsg[PLUGIN_NAME]["write"]);
	puts("</form>");

	{
		puts("<table>");
		CSString logfile;
		logfile  = env["home"];
		logfile += ini[PLUGIN_NAME]["file"];
		PrintLog(logfile);
		puts("</table>");
	}

	puts("</p></div>");

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Thumbnail View Plugin</p></div>");

	return 0;
}

int PageExtension(void)
{
	printf("<form action=\"%s%s/%s%s\" method=\"post\">\n", (string)env["album"], (string)env["script"], (string)env["vhome"], (string)env["gallery"]);
	printf( "<input type=\"hidden\" name=\"plugin\" value=\"" PLUGIN_NAME "\">\n"
			"<input type=\"hidden\" name=\"action\" value=\"write\">\n"
			"<input type=\"hidden\" name=\"folder\" value=\"%s\">\n"
			"<input type=\"text\" name=\"name\" size=\"20\">\n"
			"<input type=\"text\" name=\"log\" size=\"80\">",
			(string)env["gallery"]
	);
	printf("<input type=\"submit\" value=\"%s\">", (string)sysmsg[PLUGIN_NAME]["write"]);
	puts("</form>");

	{
		puts("<table>");
		CSString logfile;
		logfile  = env["home"];
		logfile += env["gallery"];
		logfile += '/';
		logfile += ini[PLUGIN_NAME]["file"];
		PrintLog(logfile);
		puts("</table>");
	}

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Thumbnail View Plugin</p></div>");

	return 0;
}

#if defined (__cplusplus)
}
#endif
