// pv_slideshow.cpp

/* XChV[vOC */

#define PLUGIN_NAME "slideshow.so"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{   return 1; }

int Type(void)
{   return CPlugin::PV; }

const char *Info(void)
{   return sysmsg[PLUGIN_NAME]["info"]; }

const char *Name(void)
{   return sysmsg[PLUGIN_NAME]["title"]; }

int ImageView(CImageList *imagelist)
{
	CImageList &images = *imagelist;
	int page = atoi(form["page"]);
	if(page < 0)
		page = 0;

	// skip first FORM["page"] images
	CGroup *pGrp = images.Group()->Next();
	int num = 0;
	while(pGrp && ++num < page)
		pGrp = pGrp->Next();

	do{
		CSString title;
		if(strlen((string)images[""]["title"]))
			title = (string)images[""]["title"];
		else if(strlen((string)tree[(string)env["gallery"]]["name"]))
			title = (string)tree[(string)env["gallery"]]["name"];
		else
			title = (string)env["gallery"];

		if(!pGrp){
			printf("<h4>%s</h4><p>%s</p>", (string)title, (string)sysmsg[PLUGIN_NAME]["noimage"]);
			break;
		}

		CSString path;
		path  = MakeImageURI(pGrp);

		printf("<h4>%d: %s(%s) @ %s(%s)</h4>\n", 
			num, (string)(*pGrp)["title"], pGrp->Name(),
			(string)title, (string)env["gallery"]);

		{// prev, next
			if(num > 1)
				printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">%s</a> ",
					(string)env["album"], (string)env["vhome"], (string)env["gallery"], num-1,
					(string)sysmsg[PLUGIN_NAME]["prev"]);
			else
				printf("%s ", (string)sysmsg[PLUGIN_NAME]["firstpage"]);

			if(pGrp->Next())
				printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">%s</a><br>",
					(string)env["album"], (string)env["vhome"], (string)env["gallery"], num+1,
					(string)sysmsg[PLUGIN_NAME]["next"]);
			else
				printf("%s<br>", (string)sysmsg[PLUGIN_NAME]["lastpage"]);
		}

		if(pGrp->Next())
			printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">",
				(string)env["album"], (string)env["vhome"], (string)env["gallery"], num+1);

		printf("<img src=\"%s\" width=\"%s\" height=\"%s\"><br>",
			(string)path, (string)(*pGrp)["width"], (string)(*pGrp)["height"]);

		if(pGrp->Next())
			puts("</a>");

		{// prev, next
			if(num > 1)
				printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">%s</a> ",
					(string)env["album"], (string)env["vhome"], (string)env["gallery"], num-1,
					(string)sysmsg[PLUGIN_NAME]["prev"]);
			else
				printf("%s ", (string)sysmsg[PLUGIN_NAME]["firstpage"]);

			if(pGrp->Next())
				printf("<a href=\"%sgallery/%s%s?pv="PLUGIN_NAME"&page=%d\">%s</a><br>",
					(string)env["album"], (string)env["vhome"], (string)env["gallery"], num+1,
					(string)sysmsg[PLUGIN_NAME]["next"]);
			else
				printf("%s<br>", (string)sysmsg[PLUGIN_NAME]["lastpage"]);
		}
	}while(0);

	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Slideshow Plugin</p></div>");
	return 0;
}

#if defined (__cplusplus)
}
#endif
