// thumbnail.cpp

#define PLUGIN_NAME "thumbnail.so"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include "common.h"

#if defined (__cplusplus)
extern "C" {
#endif

int IsEnable(void)
{   return 1; }

int Type(void)
{   return CPlugin::PV; }

const char *Info(void)
{   return sysmsg[PLUGIN_NAME]["info"]; }

const char *Name(void)
{   return sysmsg[PLUGIN_NAME]["title"]; }

int ImageView(CImageList *imagelist)
{
	CImageList &images = *imagelist;

	CSString title;
	if(strlen((string)images[""]["title"]))
		title = (string)images[""]["title"];
	else if(strlen((string)tree[(string)env["gallery"]]["name"]))
		title = (string)tree[(string)env["gallery"]]["name"];
	else
		title = (string)env["gallery"];

    CImage *pImg = images.Group()->Next();
    int page, page_num, num;
    // page
    {
        page     = atoi(form["page"]);
        int imagenum = images.Count();
        if(page < 0) page = 0;
        num      = atoi(ini[PLUGIN_NAME]["num"]);
        if(num <= 0) num = 10;
        page_num = (int)ceil((double)imagenum / num);

        int start;
        start = page * num;
        while(start-- > 0 && pImg)
            pImg = pImg->Next();
    }

    // title
	printf("<h4>%s(%s)</h4>\n", (string)title, (string)env["gallery"]);

    // page
    if(page_num > 1){
        puts("Page: ");
        for(int i = 0; i < page_num; i++){
            if(i == page)
                printf("%d ", i, i);
            else
                printf("<a href=\"%sgallery/%s%s?pv=" PLUGIN_NAME "&page=%d\">%d </a> ", (string)env["album"], (string)env["vhome"], (string)env["gallery"], i, i);
        }
        puts("<br>");
    }

	puts("<div id=\"images\">");

	CSString path, thumb, str;
	for(; pImg && num-- > 0 ; pImg = pImg->Next()){
		path  = MakeImageURI(pImg);
		thumb = MakeThumbnailURI(pImg);

		str.Format("<a href=\"%s\"><img src=\"%s\"></a> ",
			(string)path, (string)thumb);
		puts(str);
	}

	puts("</div>"); // images
	puts("<div align=\"right\"><p>Copyright (C) 2006 Serika-Shiki Thumbnail View Plugin</p></div>");
	return 0;
}

#if defined (__cplusplus)
}
#endif
