// sstring.h
////////////////////////////////////////

/*
 * NX (CSString)
 *   Copyright (C) 2006 肩
 */

#ifndef __SSTRING_H__
#define __SSTRING_H__ 1

#include <stdarg.h> // va_list

#ifndef BUFFER_SIZE
#define BUFFER_SIZE 32
#endif

// G[ɓ(throw)lXg
//#define _SSTRING_NOERR 0
#define _SSTRING_NOMEM 1  // s
#define _SSTRING_RANGE 2  // ͂ꂽl͈̔͂ɖ肪

////////////////////////////////////////////////////////////////////////////////
// NX
class CSString
{
protected:
	char * m_pString;
	size_t m_Length;
	size_t m_BufferSize;

////////////////////////////////////////
// \zƏ
////////////////////////////////////////
public:
	CSString();
	CSString(const CSString &str);
	CSString(const char * const str);
	CSString(const char ch);
	virtual ~CSString();

	// ̒𑪂蒼
	int Measure(void);

	// 폜
	void Empty(void);

////////////////////////////////////////
// ̏
////////////////////////////////////////
public:
	// 
	CSString & operator = (const CSString &str);
	CSString & operator = (const char * const str);
	CSString & operator = (const char ch);

	// ǉ
	CSString & operator += (const CSString &str);
	CSString & operator += (const char * const str);
	CSString & operator += (const char ch);
	inline CSString & operator << (const CSString & str)   { return *this += str; };
	inline CSString & operator << (const char * const str) { return *this += str; };
	inline CSString & operator << (const char ch)          { return *this += ch; };

	// 
	CSString   operator + (const CSString &str);
	CSString   operator + (const char * const str);
	CSString   operator + (const char ch);
//	friend CSString operator + (const char * const str1, CSString &str2);
//	friend CSString operator + (const char ch, CSString &str2);

	// t
	CSString & Format(const char *format, ...);
	CSString & FormatV(const char *format, va_list ap);
//	CSString & Printf(const char *format, ...);
//	CSString & VPrintf(const char *format, va_list ap);

	// ̑Ő󔒗ޕ폜
	CSString & Triming(void);

	// ̍Ō1؂
	int Chop(void);

////////////////////////////////////////
// obt@ւ̃ANZX
////////////////////////////////////////
public:
	// ̎o
	//inline char & operator [] (long index){ return GetAt(index); };
	inline char operator [] (long index){ return GetAt(index); };
	//char & GetAt(long index);
	char GetAt(long index);

	// ̎o
//	char *GetBuffer(int maxsize);
	const char *GetBuffer(void) const { return m_pString; };
	operator const char *() const { return (m_pString) ? m_pString : ""; };

////////////////////////////////////////
// vf̔r
////////////////////////////////////////
public:
	int operator == (const CSString &str);
	int operator == (const char *str);
	int operator == (const char ch);
//	friend int operator == (const char *str1, const CSString &str2);
//	friend int operator == (const char ch, const CSString &str);
	int operator != (const CSString &str);
	int operator != (const char *str);
	int operator != (const char ch);
//	friend int operator != (const char *str1, const CSString &str2);
//	friend int operator != (const char ch, const CSString &str);
	int operator >  (const CSString &str);
	int operator >  (const char *str);
	int operator >  (const char ch);
	int operator >= (const CSString &str);
	int operator >= (const char *str);
	int operator >= (const char ch);
	int operator <  (const CSString &str);
	int operator <  (const char *str);
	int operator <  (const char ch);
	int operator <= (const CSString &str);
	int operator <= (const char *str);
	int operator <= (const char ch);
	int Compare(const CSString &str);
	int Compare(const char *str);
	int Compare(const char ch);

////////////////////////////////////////
// ̎o
////////////////////////////////////////
public:
	inline size_t GetLength(void)     const{ return m_Length; };
	inline size_t Length(void)        const{ return m_Length; };
	inline size_t GetBufferSize(void) const{ return m_BufferSize; };

	// w肳ꂽ̐𐔂
	int Count(int ch) const;

	// countԖڂchoĂꏊԂ
	char *strchr(int ch, int count = 0) const;

	// ŌchoĂꏊT
	char *strrchr(int ch) const;

	// 񂪋󂩃eXg
	inline int IsEmpty(void) const { return (!m_pString || m_Length <= 0) ? 1 : 0; };

////////////////////////////////////////
// \bh
////////////////////////////////////////
private:
	static inline int alignment(int size){
		if(size < 0)
			throw _SSTRING_RANGE;
		return size + BUFFER_SIZE - (size % BUFFER_SIZE);
	};
};

#endif /* __SSTRING_H__ */
